// CloseButton.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "patriot.h"
#include "CloseButton.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCloseButton

#if 0	//+++ wb_
CCloseButton::CCloseButton()
{
}
#endif

/// fXgN^
CCloseButton::~CCloseButton()
{
}


BEGIN_MESSAGE_MAP(CCloseButton, CButton)
	//{{AFX_MSG_MAP(CCloseButton)
	ON_CONTROL_REFLECT(BN_CLICKED, OnClicked)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCloseButton bZ[W nh

/// 쐬
BOOL CCloseButton::Create(CWnd* pParentWnd, RECT& rect, UINT nID)
{
	// ŏ{^
	//rect.bottom = 13;
	//rect.right  = 14;

	DWORD dwStyle = WS_CHILD | WS_VISIBLE| BS_OWNERDRAW;
	BOOL  bResult = CButton::Create(_T("x"), dwStyle, rect, pParentWnd, nID);
	if (bResult) {
		ModifyStyleEx(0, WS_EX_TRANSPARENT);
	}
	return bResult;
}

/// {^ĕ`
BOOL CCloseButton::RedrawButton()
{
	// eEBhEɔwi`ʂǍɎg`
	CWnd* pwndParent = GetParent();

	RECT  rect = {0};
	GetClientRect(&rect);
	MapWindowPoints(pwndParent, &rect);
	pwndParent->RedrawWindow(&rect);
	return RedrawWindow();
}

/// Item`
void CCloseButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	if (!pDC) {
		return;
	}
	pDC->SetBkMode(TRANSPARENT);

	// g`
	CRect rectBtn;
	GetClientRect(rectBtn);

	COLORREF colorHilight = ::GetSysColor(COLOR_3DHILIGHT);
	COLORREF colorShadow  = ::GetSysColor(COLOR_3DSHADOW);

	if (m_state == BTN_MOUSEOVER) {
		pDC->Draw3dRect(rectBtn, colorHilight, colorShadow);
	} else if (m_state == BTN_MOUSEDOWN) {
		pDC->Draw3dRect(rectBtn, colorShadow, colorHilight);
	}

	// "x" ACR`
	const int IMAGE_SIZE = 7;
	POINT posImage	= {(rectBtn.Width() - IMAGE_SIZE) / 2, (rectBtn.Height() - IMAGE_SIZE) / 2};
	SIZE  sizeImage = {IMAGE_SIZE, IMAGE_SIZE};
	CRect rcImage( posImage, sizeImage);
	if (m_state == BTN_MOUSEDOWN) {
		// ACREɂ炷
		::OffsetRect(&rcImage, 1, 1);
	}

	CPen pen;
	pen.CreatePen(PS_SOLID, 0, ::GetSysColor(COLOR_BTNTEXT));

	CPen* pPenOld = pDC->SelectObject(&pen);

	pDC->MoveTo(rcImage.left	 , rcImage.top		 );
	pDC->LineTo(rcImage.right	 , rcImage.bottom	 );
	pDC->MoveTo(rcImage.left  + 1, rcImage.top		 );
	pDC->LineTo(rcImage.right + 1, rcImage.bottom	 );

	pDC->MoveTo(rcImage.left	 , rcImage.bottom - 1);
	pDC->LineTo(rcImage.right	 , rcImage.top	  - 1);
	pDC->MoveTo(rcImage.left  + 1, rcImage.bottom - 1);
	pDC->LineTo(rcImage.right + 1, rcImage.top	  - 1);

	pDC->SelectObject(pPenOld);
}

/// NbNꂽ
void CCloseButton::OnClicked()
{
	m_state = BTN_DEFAULT;
	GetParent()->PostMessage(WM_COMMAND, GetDlgCtrlID(), 0);
	GetParent()->GetParent()->PostMessage(WM_COMMAND, GetDlgCtrlID(), 0);
}

/// }EXړ.
void CCloseButton::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect rect;
	GetClientRect(rect);

	if (rect.PtInRect(point)) {
		m_state = BTN_MOUSEOVER;
		if (GetCapture() == NULL) {
			SetCapture();
		}
	} else {
		m_state = BTN_DEFAULT;
		if (GetCapture() == this) {
			ReleaseCapture();
		}
	}
	RedrawButton();
	CButton::OnMouseMove(nFlags, point);
}

/// }EX{^ꂽ
void CCloseButton::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_state = BTN_MOUSEDOWN;
	RedrawButton();
	CButton::OnLButtonDown(nFlags, point);
}

/// }EX{^ꂽ
void CCloseButton::OnLButtonUp(UINT nFlags, CPoint point)
{
	m_state = BTN_MOUSEOVER;
	RedrawButton();
	CButton::OnLButtonUp(nFlags, point);
}

/// wiFݒ
HBRUSH CCloseButton::CtlColor(CDC* pDC, UINT nCtlColor)
{
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	// TODO: enhĂяoȂꍇ͂ŃuṼnhƂ NULL ȊOԂ悤ɂĂ
	pDC->SetBkMode(TRANSPARENT);
	return NULL;
}

/// wȉ
BOOL CCloseButton::OnEraseBkgnd(CDC* pDC)
{
	pDC->SetBkMode(TRANSPARENT);
	return TRUE;
}
