/////////////////////////////////////////////////////////////////////////////
// EditUrlListDlg.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "EditUrlListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditUrlListDlg _CAO

/// RXgN^
CEditUrlListDlg::CEditUrlListDlg( CString strPath, CWnd* pParent /*=NULL*/ )
	: CDialog(CEditUrlListDlg::IDD, pParent)
	, m_strPath(strPath)
	, m_arrUrl()
	, m_arrSecure()
	, m_file()
	, m_List1()
	, m_strTitle()	// (_T(""))
	, m_strUrl()	// (_T(""))
{
  #if 0 //+++ Lɗ.
	//{{AFX_DATA_INIT(CEditUrlListDlg)
	m_strTitle = _T("");
	m_strUrl   = _T("");
	//}}AFX_DATA_INIT

	m_strPath  = strPath;
  #endif
}

///
void CEditUrlListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditUrlListDlg)
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Text(pDX, IDC_EDIT1, m_strTitle);
	DDX_Text(pDX, IDC_EDIT2, m_strUrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditUrlListDlg, CDialog)
	//{{AFX_MSG_MAP(CEditUrlListDlg)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CEditUrlListDlg bZ[W nh

/// _CAO
BOOL CEditUrlListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// XgRg[쐬
	m_List1.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_List1.InsertColumn( 0, _T("^Cg"), NULL, 190 );
	m_List1.InsertColumn( 1, _T("URL"), 	 NULL, 190 );

	LoadFile();

	if (m_List1.GetItemCount() > 0) {
		m_List1.SetItemState( 0, 2, LVIS_SELECTED );
	}
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// OK
void CEditUrlListDlg::OnOK()
{
	SaveFile();
	EndDialog(IDOK);

	CDialog::OnOK();
}

/// t@C̓ǂݍ
void CEditUrlListDlg::LoadFile()
{
  #if 1
	m_file.Load( m_strPath );

	int length = int( m_file.GetSize() );
	for (int i=0; i < length; i++) {
		m_List1.InsertItem( i, m_file.GetAt(i)->strTitle );
		m_List1.SetItemText( i, 1, m_file.GetAt(i)->strURL );
	}
  #else
	/*
	m_arrUrl.RemoveAll();
	m_arrSecure.RemoveAll();
	m_List1.ResetContent();

	CString strURL , strSet , str;
	CStdioFile fin(m_strPath , CFile::modeRead);

	while (fin.ReadString(strURL)) {
		fin.ReadString(strSet);
		m_arrUrl.Add(strURL);
		m_arrSecure.Add(strSet);
		m_List1.AddString(strURL);
		fin.ReadString(str);
	}
	fin.Close();

	if (m_List1.GetCount()>0) {
		m_List1.SetCurSel(0);
		OnSelchangeList1();
	}
	*/
  #endif
}

/// t@C̕ۑ
void CEditUrlListDlg::SaveFile()
{
  #if 1
	m_file.Save();
  #else
	/*
	CStdioFile fin(m_strPath , CFile::modeWrite | CFile::modeCreate);

	for (int i = 0;i<m_arrUrl.GetSize();i++) {
		fin.WriteString(m_arrUrl.GetAt(i)+ _T("\n") );
		fin.WriteString(m_arrSecure.GetAt(i)+ _T("\n") );
		fin.WriteString( _T("\n") );
	}
	fin.Close();
	*/
  #endif
}

/// ^Cg
void CEditUrlListDlg::OnChangeEdit1()
{
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index != -1) {
		GetDlgItemText( IDC_EDIT1, m_file.GetAt( index )->strTitle );
	}
}

/// URL
void CEditUrlListDlg::OnChangeEdit2()
{
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index != -1) {
		GetDlgItemText( IDC_EDIT2, m_file.GetAt( index )->strURL );
	}
}

/// IύXꂽ
void CEditUrlListDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	//NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;

	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index == -1) {
		return;
	}

	m_strTitle		  = m_file.GetAt(index)->strTitle;
	m_strUrl		  = m_file.GetAt(index)->strURL;
	CString strSecure = m_file.GetAt(index)->strSetting;

	UpdateData(FALSE);

	CheckDlgButton( IDC_CHECK1, strSecure.SpanExcluding(_T("2")).GetLength() );
	OnCheck1();

	for (UINT nID = IDC_CHECK2; nID <= IDC_CHECK12; nID++) {
		CheckDlgButton( nID, strSecure.GetAt(nID - IDC_CHECK2) - _T('0') );
	}
	/*
	CheckDlgButton( IDC_CHECK2,  strSecure.GetAt( 0) - _T('0') );
	CheckDlgButton( IDC_CHECK3,  strSecure.GetAt( 1) - _T('0') );
	CheckDlgButton( IDC_CHECK4,  strSecure.GetAt( 2) - _T('0') );
	CheckDlgButton( IDC_CHECK5,  strSecure.GetAt( 3) - _T('0') );
	CheckDlgButton( IDC_CHECK6,  strSecure.GetAt( 4) - _T('0') );
	CheckDlgButton( IDC_CHECK7,  strSecure.GetAt( 5) - _T('0') );
	CheckDlgButton( IDC_CHECK8,  strSecure.GetAt( 6) - _T('0') );
	CheckDlgButton( IDC_CHECK9,  strSecure.GetAt( 7) - _T('0') );
	CheckDlgButton( IDC_CHECK10, strSecure.GetAt( 8) - _T('0') );
	CheckDlgButton( IDC_CHECK11, strSecure.GetAt( 9) - _T('0') );
	CheckDlgButton( IDC_CHECK12, strSecure.GetAt(10) - _T('0') );
	*/
}

/// ZLeB
void CEditUrlListDlg::OnCheck1()
{
	BOOL bEnable = IsDlgButtonChecked(IDC_CHECK1);

	for (UINT nID = IDC_CHECK2; nID <= IDC_CHECK12; nID++) {
		GetDlgItem( nID )->EnableWindow(bEnable);
	}

	if (!bEnable) {
		int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );

		CString str;
		for (UINT nID = IDC_CHECK2; nID <= IDC_CHECK12; nID++) {
			str += _T('2');
		}
		m_file.GetAt( index )->strSetting = str;
	}
}

/// ㏑
void CEditUrlListDlg::OnCheck()
{
  #if 1
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index == -1) {
		return;
	}

	CString str;
	for (UINT nID = IDC_CHECK2; nID <= IDC_CHECK12; nID++) {
		str += TCHAR( _T('0') + IsDlgButtonChecked(nID) );
	}
	m_file.GetAt( index )->strSetting = str;
  #else
	/*
	int Index = m_List1.GetCurSel();
	// url
	CString str;m_Url.GetWindowText(str);
	m_arrUrl.SetAt(Index , str);
	m_List1.DeleteString(Index);
	m_List1.InsertString(Index , str);
	m_List1.SetCurSel(Index);

	if (((CButton*)GetDlgItem(IDC_CHECK1))->GetCheck() == 0)
		m_arrSecure.SetAt(Index, _T("2222222222") );
	else{
		CString strSecure= _T("0000000000");
		if (((CButton*)GetDlgItem(IDC_CHECK2))->GetCheck() == 1)
			strSecure.SetAt(0, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK3))->GetCheck() == 1)
			strSecure.SetAt(1, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck() == 1)
			strSecure.SetAt(2, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK5))->GetCheck() == 1)
			strSecure.SetAt(3, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK6))->GetCheck() == 1)
			strSecure.SetAt(4, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK7))->GetCheck() == 1)
			strSecure.SetAt(5, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK8))->GetCheck() == 1)
			strSecure.SetAt(6, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK9))->GetCheck() == 1)
			strSecure.SetAt(7, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK10))->GetCheck() == 1)
			strSecure.SetAt(8, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK11))->GetCheck() == 1)
			strSecure.SetAt(9, '1');
		if (((CButton*)GetDlgItem(IDC_CHECK12))->GetCheck() == 1)
			strSecure.SetAt(10, '1');
		m_arrSecure.SetAt(Index , strSecure);
	}
	*/
  #endif
}

/// ǉ
void CEditUrlListDlg::OnButton1()
{
  #if 1
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );

	CUrllistItem* pItem = new CUrllistItem;
	if (index >= 0) {
		m_file.InsertAt( index, pItem );
	} else {
		index = int( m_file.GetSize() );
		m_file.Add( pItem );
	}

	m_List1.InsertItem( index, m_file.GetAt(index)->strTitle );
	m_List1.SetItemText( index, 1, m_file.GetAt(index)->strURL );
	m_List1.SetItemState( index, 2, LVIS_SELECTED );
  #else
	/*
	m_List1.AddString( _T("") );
	m_arrUrl.Add( _T("") );
	m_arrSecure.Add( _T("2222222222") );
	m_List1.SetCurSel(m_List1.GetCount()-1);
	OnSelchangeList1();
	*/
  #endif
}

/// 폜
void CEditUrlListDlg::OnButton2()
{
  #if 1
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index == -1) {
		return;
	}

	delete m_file.GetAt( index );
	m_file.RemoveAt( index );

	m_List1.DeleteItem( index );
	if (m_List1.GetItemCount() > 0) {
		if (m_List1.GetItemCount() <= index) {// CfbNX蓖
			m_List1.SetItemState( m_List1.GetItemCount() - 1, 2, LVIS_SELECTED );
		} else {
			m_List1.SetItemState( index, 2, LVIS_SELECTED );
		}
	}
  #else
	/*
	if (m_List1.GetCurSel() == -1)
		return;
	int Index = m_List1.GetCurSel();
	m_List1.DeleteString(Index);
	m_arrUrl.RemoveAt(Index);
	m_arrSecure.RemoveAt(Index);

	if (m_List1.GetCount()>Index)
		m_List1.SetCurSel(Index);
	else if (m_List1.GetCount()>0)
		m_List1.SetCurSel(m_List1.GetCount()-1);
	OnSelchangeList1();
	*/
  #endif
}

/// 
void CEditUrlListDlg::OnButton3()
{
  #if 1
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index < 1) {
		return;
	}

	// t@C
	m_file.InsertAt( index - 1, m_file.GetAt( index ) );
	m_file.RemoveAt( index + 1 );

	// Rg[
	m_List1.SetItemText( index - 1, 0, m_file.GetAt( index - 1 )->strTitle );
	m_List1.SetItemText( index - 1, 1, m_file.GetAt( index - 1 )->strURL   );

	m_List1.SetItemText( index, 0, m_file.GetAt( index )->strTitle );
	m_List1.SetItemText( index, 1, m_file.GetAt( index )->strURL   );

	// I
	m_List1.SetItemState( index - 1, 2, LVIS_SELECTED );
  #else
	/*
	if (m_List1.GetCurSel() < 1)
		return;

	int Index = m_List1.GetCurSel();
	CString strUrl = m_arrUrl.GetAt(Index);
	CString strSecure = m_arrSecure.GetAt(Index);

	m_List1.DeleteString(Index);
	m_List1.InsertString(Index-1 , strUrl);
	m_arrUrl.SetAt(Index , m_arrUrl.GetAt(Index-1));
	m_arrSecure.SetAt(Index , m_arrSecure.GetAt(Index-1));
	m_arrUrl.SetAt(Index-1 , strUrl);
	m_arrSecure.SetAt(Index-1 , strSecure);

	m_List1.SetCurSel(Index-1);
	OnSelchangeList1();
	*/
  #endif
}

/// 
void CEditUrlListDlg::OnButton4()
{
  #if 1
	int index = m_List1.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if (index == -1 || index == m_List1.GetItemCount() - 1) {
		return;
	}

	// t@C
	m_file.InsertAt( index + 2, m_file.GetAt( index ) );
	m_file.RemoveAt( index );

	// Rg[
	m_List1.SetItemText( index, 0, m_file.GetAt( index )->strTitle );
	m_List1.SetItemText( index, 1, m_file.GetAt( index )->strURL   );

	m_List1.SetItemText( index + 1, 0, m_file.GetAt( index + 1 )->strTitle );
	m_List1.SetItemText( index + 1, 1, m_file.GetAt( index + 1 )->strURL   );

	// I
	m_List1.SetItemState( index + 1, 2, LVIS_SELECTED );
  #else
	/*
	if (m_List1.GetCurSel() < 0 || m_List1.GetCurSel() == m_List1.GetCount()-1)
		return;

	int Index = m_List1.GetCurSel();
	CString strUrl = m_arrUrl.GetAt(Index);
	CString strSecure = m_arrSecure.GetAt(Index);

	m_List1.DeleteString(Index);
	m_List1.InsertString(Index+1 , strUrl);
	m_arrUrl.SetAt(Index , m_arrUrl.GetAt(Index+1));
	m_arrSecure.SetAt(Index , m_arrSecure.GetAt(Index+1));
	m_arrUrl.SetAt(Index+1 , strUrl);
	m_arrSecure.SetAt(Index+1 , strSecure);

	m_List1.SetCurSel(Index+1);
	OnSelchangeList1();
	*/
  #endif
}

