#if !defined(PATRIOT_CLASS_IDMAP)
#define PATRIOT_CLASS_IDMAP

#include "resource.h"

#ifndef WM_GETMAINMENU
#define WM_GETMAINMENU 			(WM_USER + 113)
#endif

class CIDMap{
public:
	CStringArray m_arrStr;
	CUIntArray	 m_arrID;

	/// ftHgERXgN^
	CIDMap(){ // 
		m_arrStr.Add( _T("") );
		m_arrID.Add(0);

		static const UINT IDs[] = {
			// t@C
			ID_FILE_NEW,
			ID_FILE_OPENCLIP,
			ID_FILE_NEWTHIS,
			ID_FILE_NEWHOME,
			ID_FILE_OPEN,
			ID_FILE_SAVE,
			ID_FILE_CLOSE,
			ID_FILE_PRINT_SETUP,
			ID_FILE_PRINT,
			ID_FILE_PRINTPREVIEW,
			ID_FILE_PROPERTY,
			ID_FILE_OFFLINE,
			ID_FILE_BACKUP,
			ID_FILE_CLOSEDURL,
			ID_APP_EXIT,
			0,
			// ҏW
			ID_EDIT_CUT,
			ID_EDIT_COPY,
			ID_EDIT_PASTE,
			ID_EDIT_SELECT_ALL,
			ID_EDIT_COPY_TITLE,
			ID_EDIT_COPY_URL,
			ID_EDIT_OPENSELECTEDSTRING,
			ID_EDIT_OPENSELECTEDLINK,
			ID_EDIT_FIND,
			0,
			// \
			ID_VIEW_TOOLBAR,
			ID_VIEW_ADDRESSBAR,
			ID_VIEW_TABBAR,
			ID_VIEW_SEARCHBAR,
			ID_VIEW_LINKBAR,
			ID_VIEW_SIDEBAR,
			ID_VIEW_STATUS_BAR,
			ID_VIEW_REBAR2,
			ID_VIEW_FIXEDBAR,
			ID_VIEW_SIDEFAVORITES,
			ID_VIEW_SIDEHISTRY,
			ID_VIEW_SIDEURLLIST,
			ID_VIEW_SIDETAB,
			ID_VIEW_SIDE_AUTOHIDE,
			ID_VIEW_KEYBOARD,
			ID_VIEW_BACK,
			ID_VIEW_FORWARD,
			ID_VIEW_UPFOLDER,
			ID_VIEW_HOME,
			ID_VIEW_STOP,
			ID_VIEW_STOP_ALL,
			ID_VIEW_REFRESH,
			ID_VIEW_REFRESH_ALL,
			ID_VIEW_AUTOREFRESH,
			ID_VIEW_FONT_LARGEST,
			ID_VIEW_FONT_LEARGER,
			ID_VIEW_FONT_MIDDLE,
			ID_VIEW_FONT_SMALLER,
			ID_VIEW_FONT_SMALLEST,
			ID_VIEW_SOURCE,
			ID_VIEW_SOURCE_SELECTED,
			ID_VIEW_PRIVACYREPORT,
			0,
			// Cɓ
			ID_FAVORITES_ADD,
			ID_FAVORITES_EDIT,
			ID_FAVORITES_SAVEURLLIST,
			ID_FAVORITES_ADDURLLIST,
			ID_FAVORITES_EDITURLLIST,
			0,
			// EBhE
			ID_WINDOW_BACKTAB,
			ID_WINDOW_NEXTTAB,
			ID_WINDOW_FIRSTTAB,
			ID_WINDOW_LASTTAB,
			ID_WINDOW_SORTURL,
			ID_WINDOW_MOVELEFT,
			ID_WINDOW_MOVERIGHT,
			ID_WINDOW_MOVEFIRST,
			ID_WINDOW_MOVELAST,
			ID_WINDOW_THUMBNAIL,
			ID_FILE_CLOSEALL,
			ID_FILE_CLOSEEXCEPT,
			ID_FILE_CLOSELEFT,
			ID_FILE_CLOSERIGHT,
			ID_WINDOW_TILE_HORZ,
			ID_WINDOW_TILE_VERT,
			0,
			// c[
			ID_TOOL_ANTIPOPUP,
			ID_TOOL_NEWWINDOW,
			ID_TOOL_ACTIVETAB,
			ID_TOOL_OFFSTYLE,
			ID_TOOL_PROXY,
			ID_TOOL_PROXY_IE,
			ID_TOOL_LOADIMAGE,
			ID_TOOL_LOADBGM,
			ID_TOOL_LOADMOVIE,
			ID_TOOL_ALLMEDIAON,
			ID_TOOL_ALLMEDIAOFF,
			ID_TOOL_RUNSCRIPT,
			ID_TOOL_RUNJAVA,
			ID_TOOL_RUNACTIVEX,
			ID_TOOL_LOADACTIVEX,
			ID_TOOL_RUNON,
			ID_TOOL_RUNOFF,
			ID_TOOL_USECOOKIE,
			ID_TOOL_USECOOKIESESSION,
			ID_TOOL_SHOWSTATUS,
			ID_TOOL_FILTERUSE,
			ID_TOOL_ADDFILTER,
			ID_TOOL_ADD_CONTENT_BLOCK,
			ID_TOOL_OPTION_TOOLBAR,
			ID_TOOL_OPTIONSENDSTR,
			ID_TOOL_OPTIONEXTENSION,
			ID_TOOL_OPTION,
			ID_TOOL_INTERNETOPTION,
			0,
			// wv
			ID_HELP_GOOFFICIAL,
			ID_APP_ABOUT,
			0, 0
		};

		int i = 0;
		while (IDs[i] || IDs[i + 1]) {
			m_arrID.Add(IDs[i]);
			i++;
		}
		m_arrID.Add(0);

		// XgOe[uǂݍ
		CString str;
		m_arrStr.SetSize( m_arrID.GetSize() );
		for (i = 0; i < m_arrID.GetSize(); i++ ) {
			if (m_arrID.GetAt(i) != 0) {
				str.LoadString( m_arrID.GetAt(i) );
			} else {
				str = _T("");
			}
			if (!str.IsEmpty()) {
				str = str.Mid( str.Find(_T('\n')) + 1 );
				//str = str.Right( str.GetLength() - str.Find(_T('\n')) -1 );
			}
			m_arrStr.SetAt( i, str );
		}

		// L[{[h
		m_arrStr.Add( _T("[j[] AhXo[") );
		m_arrID .Add(ID_POPUP_ADDRESS);
		m_arrStr.Add( _T("[j[] ߂Eiޗ") );
		m_arrID .Add(ID_POPUP_TRAVELLOG);
		m_arrStr.Add( _T("[j[] ŋߕy[W") );
		m_arrID .Add(ID_POPUP_CLOSEDURL);
		m_arrStr.Add( _T("[j[] o[̒P") );
		m_arrID .Add(ID_POPUP_FINDPAGE);
		m_arrStr.Add( _T("[tH[JX] o[") );
		m_arrID .Add(ID_VIEW_FOCUS_SEARCH);
		m_arrStr.Add( _T("[tH[JX] AhX") );
		m_arrID .Add(ID_VIEW_FOCUS_ADDRESS);
		m_arrStr.Add( _T("[tH[JX] r[") );
		m_arrID .Add(ID_VIEW_FOCUS_VIEW);
		m_arrStr.Add( _T("[tH[JX] TCho[") );
		m_arrID .Add(ID_VIEW_FOCUS_SIDEBAR);
		m_arrStr.Add( _T("̃N") );
		m_arrID .Add(ID_VIEW_LINK_LEFT);
		m_arrStr.Add( _T("ẼN") );
		m_arrID .Add(ID_VIEW_LINK_RIGHT);
		m_arrStr.Add( _T("̃N") );
		m_arrID .Add(ID_VIEW_LINK_UP);
		m_arrStr.Add( _T("̃N") );
		m_arrID .Add(ID_VIEW_LINK_DOWN);
		m_arrStr.Add( _T("[tH[JX] ̍") );
		m_arrID .Add(ID_VIEW_LINKNEXT);
		m_arrStr.Add( _T("[tH[JX] O̍") );
		m_arrID .Add(ID_VIEW_LINKBACK);
		m_arrStr.Add( _T("") );
		m_arrID .Add(ID_EDIT_FINDFORWARD);
		m_arrStr.Add( _T("O") );
		m_arrID .Add(ID_EDIT_FINDBACK);
		m_arrStr.Add( _T("nCCg") );
		m_arrID .Add(ID_EDIT_HILIGHT);
		m_arrStr.Add( _T("Back") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_BACK);
//		m_arrStr.Add( _T("tab") );
//		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_TAB);
		m_arrStr.Add( _T("Return") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_RETURN);
//		m_arrStr.Add( _T("VK_ESCAPE") );
//		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_ESCAPE);
		m_arrStr.Add( _T("Page Up") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_PRIOR);
		m_arrStr.Add( _T("Page Down") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_NEXT);
		m_arrStr.Add( _T("End") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_END);
		m_arrStr.Add( _T("Home") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_HOME);
		m_arrStr.Add( _T("") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_LEFT);
		m_arrStr.Add( _T("") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_UP);
		m_arrStr.Add( _T("") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_RIGHT);
		m_arrStr.Add( _T("") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_DOWN);
		/*
		m_arrStr.Add( _T("Insert") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_INSERT);
		m_arrStr.Add( _T("Delete") );
		m_arrID .Add(ID_SPECIAL_KEYEMU+VK_DELETE);
		*/
		m_arrStr.Add( _T("") );
		m_arrID .Add(0);
	}

	/*
	/// Ō
	UINT Lookup(CString str){
		for (int i = 0;i<m_arrStr.GetSize();i++)
			if (m_arrStr.GetAt(i) == str)
				return m_arrID.GetAt(i);

		// Ȃ
		UINT uID = 0;
		UINT uNum = ( str.Find(_T(']')) > -1 ) ? _ttoi(str.Mid(str.Find(_T(']')) + 1)) : 0;
		//UINT uNum = ( str.Find(_T(']')) > -1 ) ? _ttoi( str.Right(str.GetLength()-str.Find(_T(']'))-1) ) : 0;

		if (str.Find( _T("[I𕶎𑗂]") )>-1) // I𕶎`
			uID = ID_TOOL_SENDSTRING+uNum-1;
		if (str.Find( _T("[IURL𑗂]") )>-1) // IURL`
			uID = ID_TOOL_SENDURL+uNum-1;
		if (str.Find( _T("[vNV]") )>-1) // vNV
			uID = ID_TOOL_PROXY+uNum+1;
		if (str.Find( _T("[g@\]") )>-1) // g
			uID = ID_EXTENSION_EXTENSION + uNum - 1;
		return uID;
	}
	*/

	/// IDŌ
	CString Lookup(UINT id) {	//+++@ :id  GetMenuSting Ŏg id Ȃ̂ UINT ok.
		for (int i = 0; i < m_arrID.GetSize(); i++) {
			if (m_arrID.GetAt(i) == id) {
				return m_arrStr.GetAt(i);
			}
		}
		// Ȃ
		CString str= _T("");

		// j[T
		CWnd* pMainWnd = AfxGetMainWnd();
		if (pMainWnd) {
			HMENU hMenu = reinterpret_cast<HMENU>( pMainWnd->SendMessage(WM_GETMAINMENU) );
			TCHAR lpszMenu[MAX_PATH];
			::GetMenuString( hMenu, id, lpszMenu, MAX_PATH, MF_BYCOMMAND);
			str = lpszMenu;

			int nTabPos = str.Find(_T('\t'));
			if (nTabPos > -1) {
				str = str.Left(nTabPos);
			}
			if (str.GetLength() > 4 && str.Right(4).GetAt(0) == _T('(')) {
				str = str.Left(str.GetLength() - 4);
			}

			if (!str.IsEmpty()) {
				m_arrID.InsertAt(0, id);
				m_arrStr.InsertAt(0, str);
				return str;
			}
		}

		// ԍ
		if (id >= ID_TOOL_SENDSTRING  && id <= ID_TOOL_SENDSTRING+MENU_SENDSTR_MAX-1) // I𕶎`
			str.Format( _T("[I𕶎𑗂]%d") , id-ID_TOOL_SENDSTRING+1);
		if (id >= ID_TOOL_SENDURL  && id <= ID_TOOL_SENDURL+MENU_SENDSTR_MAX-1) // IURL`
			str.Format( _T("[IURL𑗂]%d") , id-ID_TOOL_SENDURL+1);
		if (id >= ID_TOOL_PROXY+1  && id <= ID_TOOL_PROXY+MENU_SENDSTR_MAX-1) // vNV
			str.Format( _T("[vNV]%d") , id-ID_TOOL_PROXY-1);
		if (id >= ID_EXTENSION_EXTENSION  && id <= ID_EXTENSION_EXTENSION+300) // g
			str.Format( _T("[g@\]%d") , id-ID_EXTENSION_EXTENSION+1);
		return str;
	}

	/*
	int GetCategory(int Index){ // JeS[̊Jn擾
		int category = 0;
		for (int i = 0;i<m_arrStr.GetSize();i++)
			if (m_arrStr.GetAt(i)== _T("") ) {
				category++;
				if (category == Index)
					return i+1;
			}
		return 0;
	}
	*/

protected:

};


#endif
