#pragma once

#include "HtmlView2.h"
#define WM_CHANGETABINDEX		(WM_USER + 102)

class CTabsCollection {
	enum { VIEW_NUM = 2000 };		//+++ x.
	CHtmlView2* m_pView[VIEW_NUM];
	int 		m_count;

public:
	/// 
	CTabsCollection() {
		m_count = 0;
	}

  #if 1	//+++ o[ϐāAo[֐oRɕύX.
	/// ^uԂ.
	int			count() const { return m_count; }

	/// wView̃|C^Ԃ.
	CHtmlView2*	view(UINT_PTR n) const {
		assert(n < UINT_PTR(m_count) && m_pView[n] != NULL);
		return m_pView[n];
	}
  #endif

	/// ǉ.
	bool AddWnd( CHtmlView2* GetView, int index ) {
		if (m_count < VIEW_NUM) {		//+++ Ô߃`FbN.
			for (int i = m_count; i > index; i-- ) {
				m_pView[i] = m_pView[i - 1];
				m_pView[i]->SendMessage( WM_CHANGETABINDEX, i );
			}
			m_pView[index] = GetView;
			m_pView[index]->SendMessage(WM_CHANGETABINDEX, index);
			m_count++;
		}
		return true;
	}

	/// 폜.
	bool DeleteWnd(int index) {
		if (m_count) {				//+++ Ô߃`FbN.
			for (int i = index; i < m_count; i++) {
				m_pView[i] = m_pView[i + 1];
				if (i < m_count - 1) {
					m_pView[i]->SendMessage( WM_CHANGETABINDEX, i );
				}
			}
			m_count--;
		}
		return true;
	}

  #if 1	//+++ CMainFrame::OnReplaceTab ̏Ɉړ.
	/// .
	bool SwapWnd(int oldIndex, int newIndex) {
		assert(UINT(oldIndex) < UINT(m_count) && UINT(newIndex) < UINT(m_count));
		if (oldIndex != newIndex && UINT(oldIndex) < UINT(m_count) && UINT(newIndex) < UINT(m_count)) {
			CHtmlView2* pBufView	= m_pView[newIndex];
			m_pView[newIndex] 		= m_pView[oldIndex];
			m_pView[newIndex]->SendMessage( WM_CHANGETABINDEX, newIndex );
			m_pView[oldIndex]		= pBufView;
			m_pView[oldIndex]->SendMessage( WM_CHANGETABINDEX, oldIndex );
			return true;
		}
		return false;
	}
  #endif
};
