/////////////////////////////////////////////////////////////////////////////
// UrllistFile.cpp: URLXg̓ǍEۑNX
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UrllistFile.h"
#include "burapi.h"
#include "patriot.h"
#include "patriotView.h"
#include "TravellogManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// URLXg̃ACe
/////////////////////////////////////////////////////////////////////////////

#if 0	//+++ wb_ֈړ.
/// RXgN^
CUrllistItem::CUrllistItem()
	: strURL()
	, strTitle()
	, strSetting()
	, m_pBackEntries(NULL)
	, m_pForwardEntries(NULL)
{
}
#endif

/// fXgN^
CUrllistItem::~CUrllistItem()
{
	if (m_pBackEntries) {
		delete[] m_pBackEntries;
	}
	if (m_pForwardEntries) {
		delete[] m_pForwardEntries;
	}
}

/// ^uJ
void CUrllistItem::Open(BOOL bNewWindow, BOOL bActive, BOOL bAddLast)
{
	if (this->strURL.IsEmpty()) {
		return;
	}

	CHtmlView2* pView = NULL;
	if (bNewWindow) {
		pView = static_cast<CPatriotApp*>( AfxGetApp() )->NewTab( 1, bActive, bAddLast );
	} else {
		CMDIChildWnd* pChildWnd = static_cast<CMDIFrameWnd*>( AfxGetMainWnd() )->MDIGetActive();
		if (pChildWnd) {
			pView = static_cast<CHtmlView2*>( pChildWnd->GetActiveView() );
		} else {
			return;
		}
	}

	if (pView) {
		if (m_pBackEntries || m_pForwardEntries) {
			CPatriotView* pPatriotView = static_cast<CPatriotView*>(pView);
			if (pPatriotView->m_pTravelLogManager) {	//+++ Ô߃K[h.
				pPatriotView->m_pTravelLogManager->Copy(m_pBackEntries, m_pForwardEntries);
				pPatriotView->m_pTravelLogManager->SetState( CTravelLogManager::STATE_RESTORE );
			}
		}
		pView->SendMessage( WM_LOADSTRSETTING, (WPARAM)(LPCTSTR)this->strSetting );	//+++@ cast chg.
		pView->Navigate(this->strURL);
	}
}

/// ^u̐ݒ擾
void CUrllistItem::Get( CHtmlView2* pView )
{
	if (pView) {
		this->strURL   = pView->GetLocationURL();
		this->strTitle = pView->GetLocationName();

		TCHAR	lpszSetting[MAX_PATH];
		pView->SendMessage( WM_SAVESTRSETTING, (WPARAM)lpszSetting );
		this->strSetting = lpszSetting;

		// ߂Eiޗ
		CPatriotView*	pPatriotView = static_cast<CPatriotView*>(pView);
		if (g_Options.bTravellogRestore && pPatriotView->m_pTravelLogManager) {
			delete[]	m_pBackEntries;
			delete[]	m_pForwardEntries;
			m_pBackEntries	= new CTravelLogEntry[TRAVELLOG_MAX_COUNT];
			m_pForwardEntries = new CTravelLogEntry[TRAVELLOG_MAX_COUNT];

			pPatriotView->m_pTravelLogManager->Load();
			pPatriotView->m_pTravelLogManager->CopyTo(m_pBackEntries, m_pForwardEntries);

			if (m_pBackEntries[0].URL.IsEmpty()) {
				delete[]	m_pBackEntries;
				m_pBackEntries	= NULL;
			}
			if (m_pForwardEntries[0].URL.IsEmpty()) {
				delete[]	m_pForwardEntries;
				m_pForwardEntries = NULL;
			}
		}
	}
}

/// ^u̐ݒXV
void CUrllistItem::Set( CHtmlView2* pView )
{
}


/////////////////////////////////////////////////////////////////////////////
// URLXg̃t@C
/////////////////////////////////////////////////////////////////////////////

/// \z
CUrllistFile::CUrllistFile()
	: m_strFileName()
{
}

/// j
CUrllistFile::~CUrllistFile()
{
	Destroy();
}

/// t@CǍ
BOOL CUrllistFile::Load( CString strFileName )
{
	Destroy();

	if (!strFileName.IsEmpty()) {
		m_strFileName	= strFileName;
	}

	CUrllistItem* pItem = NULL;
	CReadTextFile fso;	//+++ CStdioFile fso;
	if (!fso.Open( m_strFileName, CFile::modeRead )) {
		return FALSE;
	}

	BOOL			 bTravelLog 	 = FALSE;
	int 			 nTravelLogIndex = 0;
	CTravelLogEntry* pEntries		 = NULL;

	CString str;
	fso.ReadString(str);
	while (fso.ReadString(str)) {
		// ߂Eiޗ
		if (bTravelLog) {
			// ߂闚
			if (str.Find(_T("back:"), 4) == 4) {
				pItem->m_pBackEntries = new CTravelLogEntry[TRAVELLOG_MAX_COUNT];
				pEntries			  = pItem->m_pBackEntries;
				nTravelLogIndex 	  = 0;
			// iޗ
			} else if (str.Find(_T("forward:"), 4) == 4) {
				pItem->m_pForwardEntries  = new CTravelLogEntry[TRAVELLOG_MAX_COUNT];
				pEntries				  = pItem->m_pForwardEntries;
				nTravelLogIndex 		  = 0;
			// URL
			} else if (str.Find(_T("- url: "), 6) == 6) {
				pEntries[nTravelLogIndex].URL = str.Mid( 14 );
				pEntries[nTravelLogIndex].URL.TrimRight( _T('\'') );
				pEntries[nTravelLogIndex].URL.Replace( _T("''"), _T("'") );
			// ^Cg
			} else if (str.Find(_T("title: "), 8) == 8) {
				pEntries[nTravelLogIndex].title = str.Mid( 16 );
				pEntries[nTravelLogIndex].title.TrimRight( _T('\'') );
				pEntries[nTravelLogIndex].title.Replace( _T("''"), _T("'") );
				nTravelLogIndex++;
			} else {
				bTravelLog = FALSE;
			}
		}

		// ʂ̍
		if (str.GetAt(0) == _T('-')) {
			pItem = new CUrllistItem;
			Add( pItem );
		}
		if (pItem != NULL) {
			// URL
			if (str.Find( _T("url: '")) == 2) {
				pItem->strURL = str.Mid( 8 );
				pItem->strURL.TrimRight( _T('\'') );
				pItem->strURL.Replace( _T("''"), _T("'") );
			// ^Cg
			} else if (str.Find( _T("title: '"), 2 ) == 2) {
				pItem->strTitle = str.Mid( 10 );
				pItem->strTitle.TrimRight( _T('\'') );
				pItem->strTitle.Replace( _T("''"), _T("'") );
			// ݒ
			} else if (str.Find( _T("setting: "), 2 ) == 2) {
				pItem->strSetting = str.Mid( 11 );
			// Jڗ
			} else if (str.Find( _T("travellog:"), 2 ) == 2) {
				bTravelLog = TRUE;
			}
		}
	}
	fso.Close();

	return TRUE;
}

/// t@Cۑ
BOOL CUrllistFile::Save( CString strFileName )
{
	if (!strFileName.IsEmpty()) {
		m_strFileName = strFileName;
	}

	//+++ CStdioFile fso( m_strFileName, CFile::modeCreate | CFile::modeWrite );
	CWriteTextFile fso( m_strFileName, CFile::modeCreate | CFile::modeWrite, 0/*not append*/, 1/*utf8*/);
	fso.WriteString( _T("---\n") );

	int 	nSize = int( GetSize() );
	for (int i = 0; i < nSize; i++) {
		CUrllistItem* pItem = GetAt(i);

		// URL
		if (!pItem->strURL.IsEmpty()) {
			CString str = pItem->strURL;
			str.Replace( _T("\'"), _T("\'\'") );
			fso.WriteString( _T("- url: '") + str + _T("'\n") );
		} else {
			fso.WriteString( _T("-\n") );
		}
		// ^Cg
		if (!pItem->strTitle.IsEmpty()) {
			CString str = pItem->strTitle;
			str.Replace( _T("\'"), _T("\'\'") );
			fso.WriteString( _T("  title: '") + str + _T("'\n") );
		}
		// ݒ
		if (!pItem->strSetting.IsEmpty()) {
			fso.WriteString( _T("  setting: ") + pItem->strSetting + _T("\n") );
		}
		// Jڗ
		if (pItem->m_pBackEntries || pItem->m_pForwardEntries) {
			fso.WriteString( _T("  travellog:\n") );
			if (pItem->m_pBackEntries) {
				fso.WriteString( _T("    back:\n") );
				for (int j = 0; j < TRAVELLOG_MAX_COUNT; j++) {
					if (pItem->m_pBackEntries[j].URL.IsEmpty()) {
						break;
					}
					fso.WriteString( _T("      - url: '") + pItem->m_pBackEntries[j].URL + _T("'\n") );
					fso.WriteString( _T("        title: '") + pItem->m_pBackEntries[j].title + _T("'\n") );
				}
			}
			if (pItem->m_pForwardEntries) {
				fso.WriteString( _T("    forward:\n") );
				for (int j = 0; j < TRAVELLOG_MAX_COUNT; j++) {
					if (pItem->m_pForwardEntries[j].URL.IsEmpty()) {
						break;
					}
					fso.WriteString( _T("      - url: '") + pItem->m_pForwardEntries[j].URL + _T("'\n") );
					fso.WriteString( _T("        title: '") + pItem->m_pForwardEntries[j].title + _T("'\n") );
				}
			}
		}
	}
	fso.Close();

	return TRUE;
}

/// t@CJ
BOOL CUrllistFile::Open( CString strFileName )
{
	if (strFileName.IsEmpty()) {
		return FALSE;
	}

	CUrllistFile file;
	file.Load( strFileName );

	for (int i = 0; i < file.GetSize(); i++) {
		file.GetAt(i)->Open();
	}
	return TRUE;
}

/// j
void CUrllistFile::Destroy()
{
	for (int i = 0; i < GetSize(); i++) {
		if (GetAt(i) != NULL) {
			CUrllistItem* pItem = GetAt(i);
			delete pItem;
		}
	}
	RemoveAll();
}

/// CHtmlViewǉ
int CUrllistFile::AddView( CHtmlView2* pView )
{
	CUrllistItem* pItem = new CUrllistItem;
	pItem->Get( pView );
	ASSERT(GetSize() < 0x7fffffff);
	return int( Add( pItem ) );
}
