// EditExtensionDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "EditExtensionDlg.h"
#include "..\patriotGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditExtensionDlg

IMPLEMENT_DYNAMIC(CEditExtensionDlg, CPropertySheet)

#if 0	//+++ gp.
CEditExtensionDlg::CEditExtensionDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
	, m_pageEdit()
	, m_pageInstall()
{
	AddControlPages();
}
#endif

//+++ HWNDǉ. CEditExtensionDlg::CEditExtensionDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
/// RXgN^
CEditExtensionDlg::CEditExtensionDlg(LPCTSTR pszCaption, HWND hFrameWnd, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
	, m_pageEdit(hFrameWnd)
	, m_pageInstall(hFrameWnd)
{
	AddControlPages();
}

/// fXgN^
CEditExtensionDlg::~CEditExtensionDlg()
{
}

/// vpeBV[g̒ǉ
void CEditExtensionDlg::AddControlPages()
{
	m_psh.dwFlags |= PSP_USEHICON;
	m_psh.dwFlags |= PSH_NOAPPLYNOW;   // [Kp] {^Ȃ܂
	m_psh.dwFlags &= ~PSH_HASHELP;	   // wv {^Ȃ܂

	g_Options.LoadFolderPath();

	AddPage(&m_pageEdit);
	AddPage(&m_pageInstall);
}


BEGIN_MESSAGE_MAP(CEditExtensionDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CEditExtensionDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CEditExtensionDlg bZ[W nh

/// OK
void CEditExtensionDlg::OnOK()
{
	for (int i = 0; i < GetPageCount(); i++) {
		GetPage(i)->SendMessage(WM_COMMAND, IDOK);
	}
	EndDialog(IDOK);
}

/// vOC̎CXg[
BOOL CEditExtensionDlg::ExecAutoInstall()
{
	/// extension tH_ dll, js Xgɒǉ
	CString		strExtensionFolder = g_Options.strAppPath + _T("\\extension");
	CStringList listFiles;
	FindPluginFiles( strExtensionFolder, listFiles );

	// default.ini, user.ini ̒gXg폜
	RemoveInstalledPlugins(strExtensionFolder + _T("\\default.ini"), listFiles);
	RemoveInstalledPlugins(strExtensionFolder + _T("\\user.ini"), listFiles);

	// XgɎct@CCXg[
	if (listFiles.GetCount() > 0) {
		POSITION pos	 = listFiles.GetHeadPosition();
		POSITION posTail = listFiles.GetTailPosition();

		SetActivePage( 1 );
		SetActivePage( 0 );

		while (pos) {
			CString str  = listFiles.GetAt(pos);
			UINT	nCmd = AfxMessageBox( _T("CXg[ĂȂgt@C ") + str + _T(" 𔭌܂B\ñt@CuԂBvɃCXg[܂H"), MB_YESNO | MB_ICONQUESTION );
			if (nCmd == IDYES) {
				// gCXg[
				m_pageInstall.InstallFile(strExtensionFolder + _T("\\") + str);
			}
			listFiles.GetNext(pos);
		}
	}
	return TRUE;
}

/// vOCꗗ擾
BOOL CEditExtensionDlg::FindPluginFiles(LPCTSTR lpszFolder, CStringList& list)
{
	CFileFind find;
	BOOL	  bWorking = find.FindFile(CString(lpszFolder) + _T("\\*"));
	while (bWorking) {
		bWorking = find.FindNextFile();

		if (!find.IsDirectory() && find.GetFileName().GetLength() > 3) {
			// gt@C
			CString strFilePath = find.GetFilePath();
			if (strFilePath.Right(4) == _T(".dll") || strFilePath.Right(3) == _T(".js")) {
				int nFolderPathLen = (g_Options.strAppPath + _T("\\extension\\")).GetLength();
				if (nFolderPathLen > -1) {
					list.AddTail( strFilePath.Mid(nFolderPathLen) );
				}
			}
		} else if (find.IsDirectory() && !find.IsDots()) {
			// tH_
			FindPluginFiles(find.GetFilePath(), list);
		}
	} while(find.FindNextFile());
	return TRUE;
}

///  vOCꗗCXg[ς݂폜
BOOL CEditExtensionDlg::RemoveInstalledPlugins(LPCTSTR lpszSectionFile, CStringList& list)
{
	// ini ǂݍ
	const int section_names_size = MAX_PATH * 256;
	TCHAR	  lpszSectionNames[section_names_size];
	::GetPrivateProfileSectionNames(lpszSectionNames, section_names_size, lpszSectionFile);

	LPTSTR lpszSction = lpszSectionNames;
	while (*lpszSction != _T('\0')) {
		// g@\gpt@C擾
		TCHAR	lpszFileName[MAX_PATH];
		::GetPrivateProfileString(lpszSction, _T("src"), _T(""), lpszFileName, MAX_PATH, lpszSectionFile);
		if (lstrlen(lpszFileName) == 0) {
			::GetPrivateProfileString(lpszSction, _T("dll"), _T(""), lpszFileName, MAX_PATH, lpszSectionFile);
		}
		if (lstrlen(lpszFileName) > 0) {
			// Xgɑ݂΍폜
			POSITION pos = list.GetHeadPosition();
			while (pos != NULL) {
				if (list.GetAt(pos) == lpszFileName) {
					list.RemoveAt(pos);
					break;
				}
				list.GetNext(pos);
			}
		}
		lpszSction += lstrlen(lpszSction) + 1;
	}
	return TRUE;
}

/// _CAO
BOOL CEditExtensionDlg::OnInitDialog()
{
	BOOL	bResult = CPropertySheet::OnInitDialog();
	ShowWindow(SW_SHOW);
	DoEvents();
	ExecAutoInstall();
	return bResult;
}
