// PageEditmenu.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageEditmenu.h"
#include "..\patriotGlobal2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageEditmenu vpeB y[W

IMPLEMENT_DYNCREATE(CPageEditmenu, CPropertyPage)

/// ftHgERXgN^
CPageEditmenu::CPageEditmenu()
	: CPropertyPage(CPageEditmenu::IDD)
	, m_strFileName()
	, m_strIniName()
{
	m_bSaved = TRUE;
	//{{AFX_DATA_INIT(CPageEditmenu)
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageEditmenu::~CPageEditmenu()
{
}

///
void CPageEditmenu::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageEditmenu)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageEditmenu, CPropertyPage)
	//{{AFX_MSG_MAP(CPageEditmenu)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageEditmenu bZ[W nh

/// ݒۑ
void CPageEditmenu::OnOK()
{
	SaveFile();
	CPropertyPage::OnOK();
}

/// t@CJ
void CPageEditmenu::OpenFile()
{
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	pList2->ResetContent();
	CString strFile = m_strFileName;

	CString str;
	//+++ CStdioFile sfo(GetAppPath() + strFile , CFile::modeRead);
	CReadTextFile sfo(GetAppPath() + strFile , CFile::modeRead);
	while(sfo.ReadString(str))
		pList2->AddString(str);
	sfo.Close();

	if (pList2->GetCount()>0)
		pList2->SetCurSel(0);
}

/// t@Cۑ
void CPageEditmenu::SaveFile()
{
	if (m_bSaved)
		return;
	m_bSaved = TRUE;
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	CString strFile = m_strFileName;

	CString str;
	//+++ CStdioFile sfo(GetAppPath() + strFile , CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile sfo(GetAppPath() + strFile , CFile::modeCreate | CFile::modeWrite);
	for (int i = 0;i<pList2->GetCount();i++) {
		pList2->GetText(i , str);
		sfo.WriteString(str+ _T("\n") );
	}
	sfo.Close();
}

/// AvP[ṼpX
CString CPageEditmenu::GetAppPath()
{
 #if 0
	/*
	CString strAppPath = AfxGetApp()->m_pszHelpFilePath;
	strAppPath = strAppPath.Left(strAppPath.ReverseFind('\\'));
	return strAppPath;
	*/
 #else
	return g_Options.strOptionPath + _T("\\");
 #endif
}

/// _CAO
BOOL CPageEditmenu::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// ini烊Xgǂݍ
	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
	LoadIniSectionNamesToCombobox( GetAppPath() + m_strIniName, pList1 );

	if (m_strFileName ==  _T("addrmenu.dat") ) {
		LoadIniSectionNamesToCombobox( GetAppPath() + _T("\\sendstr.ini"), pList1 );
	}
	pList1->AddString( _T("----------------") );
	pList1->SetCurSel(0);
	//
	/*
	TCHAR chrBuf[1024*32];
	::GetPrivateProfileSectionNames(chrBuf , 1024*32 , GetAppPath()+ _T("\\option\\sendstr.ini") );

	LPTSTR pChr = chrBuf;
	while (*pChr != '\0'){
		pList1->AddString(pChr);
		pChr += strlen(pChr) + 1;
	}
	*/

	// ݂̃Xgǂݍ
	OpenFile();
	SetWindowText( _T("") );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ǉ
void CPageEditmenu::OnButton1()
{
	m_bSaved = FALSE;
	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	int 	  Index  = pList2->GetCurSel();
	if (Index == -1)
		Index = pList2->GetCount();

	CString str;
	pList1->GetText(pList1->GetCurSel() , str);
	pList2->InsertString(Index , str);
	pList2->SetCurSel(Index);
}

/// 폜
void CPageEditmenu::OnButton2()
{
	m_bSaved = FALSE;
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	int 	  Index  = pList2->GetCurSel();
	if (Index == -1)
		return;

	pList2->DeleteString(Index);
	if (Index < pList2->GetCount())
		pList2->SetCurSel(Index);
	else if (pList2->GetCount()>0)
		pList2->SetCurSel(pList2->GetCount()-1);
}

/// 
void CPageEditmenu::OnButton3()
{
	m_bSaved = FALSE;
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	int 	  Index  = pList2->GetCurSel();
	if (Index < 1)
		return;

	CString str;
	pList2->GetText(Index-1 , str);
	pList2->DeleteString(Index-1);
	pList2->InsertString(Index , str);
	pList2->SetCurSel(Index-1);
}

/// 
void CPageEditmenu::OnButton4()
{
	m_bSaved = FALSE;
	CListBox* pList2 = (CListBox*)GetDlgItem(IDC_LIST2);
	int 	  Index  = pList2->GetCurSel();
	if (Index < 0 || Index == pList2->GetCount()-1)
		return;

	CString str;
	pList2->GetText(Index , str);
	pList2->DeleteString(Index);
	pList2->InsertString(Index+1 , str);
	pList2->SetCurSel(Index+1);
}
