// PageStartup.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageStartup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageStartup vpeB y[W

IMPLEMENT_DYNCREATE(CPageStartup, CPropertyPage)

/// ftHgERXgN^
CPageStartup::CPageStartup() : CPropertyPage(CPageStartup::IDD)
{
	//{{AFX_DATA_INIT(CPageStartup)
	m_DefaultAction 	= -1;
	m_Offline			= FALSE;
	m_CloseStartupApp	= FALSE;
	m_StartupAppPath	= _T("");
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageStartup::~CPageStartup()
{
}

///
void CPageStartup::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageStartup)
	DDX_CBIndex(pDX, IDC_COMBO1, m_DefaultAction);
	DDX_Check(pDX, IDC_CHECK1, m_Offline);
	DDX_Check(pDX, IDC_CHECK2, m_CloseStartupApp);
	DDX_Text(pDX, IDC_EDIT1, m_StartupAppPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageStartup, CPropertyPage)
	//{{AFX_MSG_MAP(CPageStartup)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageStartup bZ[W nh

/// NAvI
void CPageStartup::OnButton1()
{
	CString str;
	GetDlgItemText(IDC_EDIT1, str);
	CFileDialog dlg(TRUE,  _T(""), str, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, _T("st@C(*.exe)|*.exe|SẴt@C(*.*)|*.*"), this);
	if (dlg.DoModal() == IDOK) {
		GetDlgItem(IDC_EDIT1)->SetWindowText(dlg.GetPathName());
	}
}

/// _CAO
BOOL CPageStartup::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// ݒǂݍ
	// N
	m_DefaultAction   = g_Options.StartAction;
	m_Offline		  = AfxGetApp()->GetProfileInt( _T("Main"),  _T("Offline"), FALSE);
	m_StartupAppPath  = g_Options.strStartupAppPath;
	m_CloseStartupApp = g_Options.bCloseStartupApp;

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageStartup::OnOK()
{
	// N
	AfxGetApp()->WriteProfileInt( _T("Main"),  _T("Offline"), m_Offline);
	g_Options.StartAction		= m_DefaultAction;
	g_Options.strStartupAppPath = m_StartupAppPath;
	g_Options.bCloseStartupApp	= m_CloseStartupApp;

	CPropertyPage::OnOK();
}
