// PageToolbarEdit.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageToolbarEdit.h"
#include "DlgToolbarButton.h"

#include "..\burapi.h"
#include "..\patriotGlobal2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageToolbarEdit vpeB y[W

IMPLEMENT_DYNCREATE(CPageToolbarEdit, CPropertyPage)

/// RXgN^
//+++ hFrameWndǉ.  CPageToolbarEdit::CPageToolbarEdit()
CPageToolbarEdit::CPageToolbarEdit(HWND hFrameWnd)
	: CPropertyPage(CPageToolbarEdit::IDD)
	, m_hFrameWnd(hFrameWnd/*+++0*/)
	, m_pImageList(0)
	, m_bSaveModified(0)
{
	//{{AFX_DATA_INIT(CPageToolbarEdit)
		//  - ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageToolbarEdit::~CPageToolbarEdit()
{
}

///
void CPageToolbarEdit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageToolbarEdit)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageToolbarEdit, CPropertyPage)
	//{{AFX_MSG_MAP(CPageToolbarEdit)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageToolbarEdit bZ[W nh

/// _CAO
BOOL CPageToolbarEdit::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	CListCtrl* pList = (CListCtrl*)GetDlgItem(IDC_LIST1);
	pList->SetImageList( m_pImageList , LVSIL_SMALL );

	// \[X̃tH_擾
	TCHAR pszBuffer[MAX_PATH];
	::SendMessage( m_hFrameWnd , BURAPI_GET_SPECIAL_FOLDER , BURA_SPFOLDER_RESOURCE, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strResPath = pszBuffer;
	// `t@Cǂݍ
	//+++ CStdioFile fileDefine( strResPath +  _T("\\toolbar.dat")	, CFile::modeRead);
	CReadTextFile fileDefine( strResPath +	_T("\\toolbar.dat")  , CFile::modeRead);
	CString str;

	int nIndex = 0;
	while ( fileDefine.ReadString( str ) ) {
		// CmdID
		CString strCmd;
		SplitStr( str , _T(',') , strCmd , str );
		UINT nID = _ttoi( strCmd );
		// x
		CString strLabel;
		SplitStr( str , _T(',') , strLabel , str );
		// Bitmap
		int nBitmap = _ttoi( str );

		pList->InsertItem( nIndex , strLabel , nBitmap );
		pList->SetItemData( nIndex , nID );
		nIndex++;
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒ̕ۑ
void CPageToolbarEdit::OnOK()
{
	SaveToolbar();
}

/// ǉ
void CPageToolbarEdit::OnButton1()
{
	CListCtrl* pList = static_cast<CListCtrl*>( GetDlgItem(IDC_LIST1) );

	int nIndex = pList->GetItemCount();
	pList->InsertItem( nIndex , _T("") , 0 );
	pList->SetItemData( nIndex , 0 );
	pList->SetItemState( nIndex , LVIS_SELECTED | LVIS_FOCUSED , LVIS_SELECTED | LVIS_FOCUSED );

	SendMessage( WM_COMMAND , IDC_BUTTON2 );

	if ( pList->GetItemData(nIndex) == 0 ) {
		pList->DeleteItem( nIndex );
	}
}

/// ҏW
void CPageToolbarEdit::OnButton2()
{
	CListCtrl* pList = static_cast<CListCtrl*>( GetDlgItem(IDC_LIST1) );

	// I𒆂̃ACe擾
	int index = pList->GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if ( index < 0 ) {
		return;
	}

	// _CAO
	CDlgToolbarButton dlg;
	dlg.m_pImageList = m_pImageList;


	TCHAR pszText[MAX_PATH];
	LVITEM item;
	item.iItem		= index;
	item.iSubItem	= 0;
	item.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	item.pszText	= pszText;
	item.cchTextMax = MAX_PATH;
	pList->GetItem( &item );

	dlg.m_nCmdID	= UINT( item.lParam );
	dlg.m_nBitmap	= item.iImage;
	dlg.m_strLabel	= item.pszText;

	if ( dlg.DoModal() == IDOK ) {
		item.iItem		= index;
		item.iSubItem	= 0;
		item.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
		item.pszText	= const_cast<LPTSTR>( static_cast<LPCTSTR>( dlg.m_strLabel ) );
		item.cchTextMax = dlg.m_strLabel.GetLength();
		item.iImage 	= dlg.m_nBitmap;
		item.lParam 	= dlg.m_nCmdID;

		pList->SetItem( &item );

		m_bSaveModified = TRUE;
	}
}

/// 폜
void CPageToolbarEdit::OnButton3()
{
	CListCtrl* pList = static_cast<CListCtrl*>( GetDlgItem(IDC_LIST1) );

	int index = pList->GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if ( index < 0 ) {
		return;
	}

	pList->DeleteItem( index );
	m_bSaveModified = TRUE;
}

/// ۑ
void CPageToolbarEdit::SaveToolbar()
{
	if ( !m_bSaveModified ) {
		return;
	}

	CListCtrl* pList = (CListCtrl*)GetDlgItem(IDC_LIST1);
	// \[X̃tH_擾
	TCHAR pszBuffer[MAX_PATH];
	::SendMessage( m_hFrameWnd, BURAPI_GET_SPECIAL_FOLDER, BURA_SPFOLDER_RESOURCE, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strResPath = pszBuffer;

	// `t@Cۑ.
	//+++ CStdioFile fileDefine( strResPath + _T("\\toolbar.dat"), CFile::modeWrite | CFile::modeCreate );
	CWriteTextFile fileDefine( strResPath + _T("\\toolbar.dat"), CFile::modeWrite | CFile::modeCreate );
	CString str;

	for ( int i=0; i < pList->GetItemCount(); i++ ) {
		TCHAR pszText[MAX_PATH];
		LVITEM item;
		item.iItem		= i;
		item.iSubItem	= 0;
		item.mask		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
		item.pszText	= pszText;
		item.cchTextMax = MAX_PATH;
		pList->GetItem( &item );

		str.Format( _T("%d,%s,%d\n") , item.lParam , item.pszText , item.iImage );
		fileDefine.WriteString( str );
	}
	fileDefine.Close();
}
