///////////////////////////////////////////////////////////////////
// FavoritesOrder.h
// Cɓ̕яǗNX
// Marged from unDonut
///////////////////////////////////////////////////////////////////

#pragma once

#include <vector>
#include <boost/shared_ptr.hpp>

///////////////////////////////////////////////////////////////////
// CFavoritesOrder
///////////////////////////////////////////////////////////////////

class CFavoritesOrder
{
public:
	//+++ typedef struct _FavoritesOrderDataHeader
	struct OrderDataHeader
	{
		DWORD dwSize8;		//8Œ
		DWORD dwUnknown;	//s l͏2
		DWORD dwFullSizem8; //f[^Ŝ̃TCY-8
		DWORD dwUnknown2;	//s l͏1
		DWORD dwItemCount;	//ACě
	} /*OrderDataHeader*/;

	//+++ : @\I c++0x std::shared_ptr ᕨȂ݂boostłKv.
	typedef boost::shared_ptr<ITEMIDLIST> ItemIdListSharedPtr;

	enum { s_itemsize_without_idl = 12 }; //idlName\̃TCY

protected:

	// Thanks to fub and namazu
	class CFavoritesOrderData
	{
	public:
		BOOL				padding;
		DWORD				size;
		LONG				priority;
		DWORD				flag;
		ItemIdListSharedPtr spidl; // relative idlist
		CString 			name;

		/// RXgN^
		CFavoritesOrderData();
		/// Rs[RXgN^
		CFavoritesOrderData(const CFavoritesOrderData& data);
		/// fXgN^
		~CFavoritesOrderData();
		/// D揇ʂݒ
		void SetPriority(int _priority);
		/// IDLIST ݒ
		void SetPidl(ITEMIDLIST* _pidl);
		/// oCg擾
		int GetSize();
		/// IDLIST XV
		void RefreshIdl();
		/// Zq
		CFavoritesOrderData& operator=(const CFavoritesOrderData& data);
	};

	typedef std::vector<CFavoritesOrderData> CFavoritesOrderDataVector;
	CFavoritesOrderDataVector	m_datalist;
	OrderDataHeader 			m_header;
	CString 					m_strFolder;

	/// URL ŗACer
	struct LessFavoritesDataByName /*+++ : std::less<CFavoritesOrderData>
	{
		bool operator()(const CFavoritesOrderData& x, const CFavoritesOrderData& y) const;
	}*/;

public:
	/// яWXgɕۑ
	BOOL SaveOrder();
	/// z̕яWXgǂݍ
	BOOL LoadOrder(LPCTSTR lpszFolder);
	/// ACëʒuύX
	BOOL Move(int nOldIndex, int nNewIndex);
	/// ACeύX
	BOOL Rename(int Index, LPCTSTR lpszFileName);
	/// ACetH_ɒǉ
	BOOL Insert(int InsertIndex, LPCTSTR lpszFileName);
	/// ACe폜
	BOOL Delete(int TargetIndex);
	/// z̃TCY擾
	int GetCount();

	/// ITEMIDLIST쐬
	static ITEMIDLIST* CreateItemIdList(UINT cbSize);
	/// ITEMIDLISTJ
	static BOOL ReleaseItemIdList(ITEMIDLIST* pidl);
	/// ITEMIDLIST擾
	static ITEMIDLIST* GetItemIdList(LPCTSTR lpszPath);
	/// ITEMIDLIST̃TCY擾
	static int GetItemIdListSize(LPCITEMIDLIST pidl);
	/// ITEMIDLIST擾
	static ITEMIDLIST* ConvertItemIDListRelative(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
};
