/////////////////////////////////////////////////////////////////////////////
// PatriotStatusbar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "PatriotStatusbar.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const UINT s_indicators[] =		//+++ constǉ.
{
	ID_SEPARATOR,			// Xe[^X C CWP[^
	ID_INDICATOR_PROXY,
	ID_INDICATOR_PROGRESS,
	ID_INDICATOR_OFFLINE,
	ID_INDICATOR_PRIVACY,
	ID_INDICATOR_SSL,
	0xffffffff
	// ID_INDICATOR_SCRL,
};
/////////////////////////////////////////////////////////////////////////////
// PatriotStatusbar

/// ftHgERXgN^
PatriotStatusbar::PatriotStatusbar()
{
	m_bIconState[0] = m_bIconState[1] = m_bIconState[2] = 0;
	m_hIconMap	[0] = m_hIconMap  [1] = m_hIconMap	[2] = 0;
}

/// fXgN^
PatriotStatusbar::~PatriotStatusbar()
{
}


BEGIN_MESSAGE_MAP(PatriotStatusbar, CStatusBar)
	//{{AFX_MSG_MAP(PatriotStatusbar)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI_RANGE(ID_INDICATOR_OFFLINE , ID_INDICATOR_SSL , OnUpdateIndicator)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// PatriotStatusbar bZ[W nh

/// \z
int PatriotStatusbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CStatusBar::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetIndicators(s_indicators, sizeof(s_indicators) / sizeof(UINT));
	SetPaneStyle(0 , SBPS_NORMAL | SBPS_STRETCH);
	SetPaneStyle(6 , SBPS_NOBORDERS);
	// C[Wǂ݂
	CImageList	imgHot;
	CBitmap 	BMP_Tool;
	HBITMAP 	BMP_baf;
	imgHot.DeleteImageList();
	imgHot.Create(16 , 16 , ILC_MASK | ILC_COLOR16 , 0 , 30);
	BMP_baf = ( HBITMAP )::LoadImage(NULL , g_Options.strAppPath +	_T("\\res\\status.bmp") , IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach(BMP_baf);
	imgHot.Add(&BMP_Tool , RGB(255, 0, 255));

	m_hIconMap[0] = imgHot.ExtractIcon(0);
	m_hIconMap[1] = imgHot.ExtractIcon(1);
	m_hIconMap[2] = imgHot.ExtractIcon(2);
	/*
	BMP_Tool.DeleteObject();
	imgCool.DeleteImageList();
	imgCool.Create(16 , 16 , ILC_MASK | ILC_COLOR16 , 0 , 30);
	BMP_baf = ( HBITMAP )::LoadImage(NULL , g_Options->strAppPath +  _T("\\res\\statuscool.bmp") , IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach(BMP_baf);
	imgCool.Add(&BMP_Tool , RGB(255, 0, 255));
	*/
	return 0;
}

/// NbN
void PatriotStatusbar::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rect;
	// vNV؂ւ
	GetItemRect(1 , rect);
	if (rect.PtInRect(point)) {
		CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();

		ClientToScreen(rect);
		pMainFrame->GetSpecialMenu(SPMENU_PROXY)->TrackPopupMenu(TPM_LEFTALIGN, rect.left, rect.bottom, this);
	}
	// ItC
	GetItemRect( 3, rect );
	if (rect.PtInRect(point)) {
			AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_FILE_OFFLINE );
	}
	CStatusBar::OnLButtonDown(nFlags, point);
}

/// _uNbN
void PatriotStatusbar::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CRect rect;
	// vCoV[|[g
	GetItemRect(4 , rect);
	if ( rect.PtInRect(point) ) {
		AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_VIEW_PRIVACYREPORT );
	}
	// SSL
	GetItemRect(5 , rect);
	if ( rect.PtInRect(point) ) {
		AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_VIEW_SECURITY_CERTIFICATE );
	}
	CStatusBar::OnLButtonDblClk(nFlags, point);
}

///
void PatriotStatusbar::OnUpdateIndicator(CCmdUI* pCmdUI)
{
	UINT nIndex = CommandToIndex( pCmdUI->m_nID );
	GetStatusBarCtrl().SetIcon( nIndex , m_bIconState[nIndex-3] ? m_hIconMap[nIndex-3] : NULL );
	pCmdUI->Enable();
 //	GetStatusBarCtrl().SetIcon(4 , imgHot.ExtractIcon(1));
 //	GetStatusBarCtrl().SetIcon(5 , imgHot.ExtractIcon(2));
}

/// ACRԂݒ肷.
void PatriotStatusbar::SetIconState( int nIndex , BOOL bEnable )
{
	assert( UINT(nIndex) < 3 );
	m_bIconState[nIndex] = bEnable;
 //	GetStatusBarCtrl().SetIcon( nIndex+3 , m_bIconState[nIndex] ? m_hIconMap[nIndex] : NULL );
}
