#if !defined(AFX_PATRIOTTABBAR_H__B38E40E0_1389_11D6_879B_D1DDCC4FA02C__INCLUDED_)
#define AFX_PATRIOTTABBAR_H__B38E40E0_1389_11D6_879B_D1DDCC4FA02C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PatriotTabbar.h : wb_[ t@C
//
#include "DropTarget.h"
#include "TabsCollection.h"
/////////////////////////////////////////////////////////////////////////////
// CPatriotTabbar EBhE

class CPatriotTabbar : public CTabCtrl
{
// RXgNV
private:
	CFont				m_Font;
public:
	CMenu				m_menuContext;
	CImageList			m_Images;
private:
	COLORREF			m_crSelColor;
	COLORREF			m_crUnselColor;
	CFont				m_SelFont;
	CFont				m_UnselFont;
	CPoint				m_posClicked;
public:
	CSize				m_TabSize;

private:
	int 				m_ClickedTab;
	int 				m_DragedTab;
	CTabsCollection*	m_pTabs;
	CDropTarget 		m_oDropTarget;

public:
	CPatriotTabbar();
	void MouseEvents(int Index , CPoint point);
	void SetFonts(int nSelWeight = FW_SEMIBOLD, BOOL bSelItalic = FALSE,   BOOL bSelUnderline = FALSE,
				  int nUnselWeight = FW_MEDIUM, BOOL bUnselItalic = FALSE, BOOL bUnselUnderline = FALSE);
	void SetMenuCheck(UINT nID);
	void LoadOptions();
	void LoadIcons();
	void OnDropFiles(HDROP hDropInfo);
	void SetTabs(CTabsCollection* pTabs) { m_pTabs = pTabs; }				//+++

// Agr[g
public:

// Iy[V
public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPatriotTabbar)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CPatriotTabbar();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CPatriotTabbar)
	afx_msg void OnSelchange(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnFileCloseexcept();
	afx_msg void OnFileCloseleft();
	afx_msg void OnFileCloseright();
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PATRIOTTABBAR_H__B38E40E0_1389_11D6_879B_D1DDCC4FA02C__INCLUDED_)
