/////////////////////////////////////////////////////////////////////////////
// SidebarHistory.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "SidebarHistory.h"
#include "MainFrm.h"
#include <Urlhist.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSidebarHistory

/// ftHgERXgN^
CSidebarHistory::CSidebarHistory()
	: m_Images()
	, m_arrDateandUrl()
	, m_arrTitle()
	, m_arrHandle()
{
	m_bLoaded = FALSE;
	memset(&m_ClickedItem, 0, sizeof m_ClickedItem);
}

/// fXgN^
CSidebarHistory::~CSidebarHistory()
{
}


BEGIN_MESSAGE_MAP(CSidebarHistory, CTreeCtrl)
	//{{AFX_MSG_MAP(CSidebarHistory)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDED, OnItemexpanding)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_SIDEBAR_OPEN, OnSidebarOpen)
	ON_COMMAND(ID_SIDEBAR_OPENNEW, OnSidebarOpennew)
	ON_COMMAND(ID_SIDEBAR_REFRESHALL, OnSidebarRefreshall)
	ON_COMMAND(ID_SIDEBAR_DATESORTMODE, OnSidebarDatesortmode)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////

/// History\z
void CSidebarHistory::AddFolder()
{
	CString strCur = GetItemText(GetSelectedItem());
	CString strDate;

	// NbNꂽt𕶎ɕϊ
	CTime tNow = CTime::GetCurrentTime();
	if (strCur.Right(6)== _T("TԑO")) {
		// `TԑO
		if (strCur.Left(1) == _T("3")) {
			strDate= _T("11  3 week");
		} else if (strCur.Left(1) == _T("2")) {
			strDate= _T("12  2 week");
		} else if (strCur.Left(1) == _T("1")) {
			strDate= _T("13  1 week");
		}
	} else {
		// j
		if (strCur== _T("") ) {
			strDate = tNow.Format( _T("%Y/%m/%d") );
		} else{
			int    i;
			CTime  tDate;
			static LPCTSTR strDayOfWeek[6] = { _T("j"), _T("j"), _T("Ηj"), _T("j"), _T("ؗj"), _T("j") };
			for (i = 0; i < 6; i++) {
				if (strCur == strDayOfWeek[i]) {
					break;
				}
			}
			/*
			if (strCur== _T("j") ) {
				i = 1;
			} else if (strCur== _T("j") ) {
				i = 2;
			} else if (strCur== _T("j") ) {
				i = 3;
			} else if (strCur== _T("Ηj") ) {
				i = 4;
			} else if (strCur== _T("j") ) {
				i = 5;
			} else if (strCur== _T("ؗj") ) {
				i = 6;
			} else if (strCur== _T("j") ) {
				i = 7;
			}
			*/
			CTimeSpan Tspan(tNow.GetDayOfWeek() - i, 0 , 0 , 0);
			tDate	= tNow - Tspan;
			strDate = tDate.Format( _T("%Y/%m/%d") );
		}
	}

	// NbNꂽtƈv闚c[ɒǉ
	HTREEITEM ItemFolder	 = NULL;
	HTREEITEM ItemMyComputer = InsertItem( _T("}C Rs[^"), 10, 11, GetSelectedItem(), TVI_LAST);
	CString   strDomain 	 = _T("|||");

	for (int i = 0; i < m_arrDateandUrl.GetSize(); i++) {
		const CString str = m_arrDateandUrl.GetAt(i);
		if (str.GetLength() > 10 && str.Left(10) == strDate) {
			if (str.Find(strDomain) == -1 && str!= _T("11  3 week http://") ) {
				strDomain = str.Mid( 11 );

				if (strDomain.Left(5) != _T("http:") && strDomain.Left(6) != _T("https:") && strDomain.Left(4) != _T("ftp:") ) {
					// m̃hC = [Jt@C
					strDomain= _T("}C Rs[^");
				} else if (strDomain.Find( _T("://"), 0) >= 0) {
					// "http://") ̍폜
					strDomain = strDomain.Mid(strDomain.Find( _T(":") ) + 3);
					if (strDomain.Find( _T("/"), 0) >= 0) {
						// "/" ȉ̍폜
						strDomain = strDomain.Left(strDomain.Find( _T("/"), 0));
					}
					if (strDomain.Left(4)== _T("www.") ) {// www̍폜
						strDomain = strDomain.Right(strDomain.GetLength() - 4);
					}
				}

				if (strDomain!= _T("}C Rs[^") ) {
					ItemFolder = InsertItem(strDomain, 10, 11, GetSelectedItem(), TVI_LAST);
				} else {
					ItemFolder = ItemMyComputer;
				}
			}
			HTREEITEM handle = InsertItem(m_arrTitle.GetAt(i), 6, 7, ItemFolder, TVI_LAST);
			m_arrHandle.SetAt(i, (void*)handle);		//+++@ cast chg.
		}
	}
	// pTree->InsertItem( _T("")  , 10 , 11 , TVI_ROOT , TVI_LAST);
}

/// f[^ǉ
void CSidebarHistory::LoadData()
{
	static bool s_flag = true;
	if (s_flag) {
		s_flag = false;
	} else {
		return;
	}
	/*
	// C[W̃[h
	CString strBmpPath = g_Options.strAppPath + _T("\\res\\sidebar.bmp");
	CBitmap BMP_Tool;
	HBITMAP BMP_baf;
	m_Images.Create(16, 16, ILC_MASK | ILC_COLOR16, 0, 30);
	BMP_baf = ( HBITMAP )::LoadImage(NULL, strBmpPath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach(BMP_baf);
	m_Images.Add(&BMP_Tool, RGB(255, 0, 255));

	SetImageList(&m_Images, TVSIL_NORMAL);
	*/

	if (g_Options.HistorySortDate) {
		InsertItem( _T("NbNœǂݍ"), 8, 9, TVI_ROOT, TVI_LAST);
	} else {
		LoadWeekly();
	}
}

/// j
void CSidebarHistory::LoadWeekly()
{
	LPCTSTR strWeeks[3] = { _T("3TԑO"), _T("2TԑO"), _T("1TԑO") };
	for (int i = 0; i < 3; i++) {
		InsertItem( _T("no child"), 6, 7, InsertItem( strWeeks[i], 8, 9, TVI_ROOT, TVI_LAST), TVI_LAST );
	}

	static LPCTSTR strDayOfWeek[7] = { _T("j"), _T("j"), _T("Ηj"), _T("j"), _T("ؗj"), _T("j") };
	CTime Time = CTime::GetCurrentTime();
	int DayOfWeek = Time.GetDayOfWeek() - 1;
	for (int j = 0; j < DayOfWeek; j++) {
		InsertItem( _T("no child"), 6, 7, InsertItem( strDayOfWeek[j], 8, 9, TVI_ROOT, TVI_LAST), TVI_LAST );
	}

	InsertItem( _T("no child"), 6, 7, InsertItem( _T(""), 8, 9, TVI_ROOT, TVI_LAST), TVI_LAST );
}

/// ̃[h
void CSidebarHistory::LoadHistory()
{
	IUrlHistoryStg2* pHistory;
	IEnumSTATURL*	 URLs;
	_STATURL		 url;

	// XTԑO
	CTime	  m_Date;
	CTime	  tNow = CTime::GetCurrentTime();
	CTimeSpan tWeek1( 1 + tNow.GetDayOfWeek(), 0, 0, 0);
	CTimeSpan tWeek2( 8 + tNow.GetDayOfWeek(), 0, 0, 0);
	CTimeSpan tWeek3(15 + tNow.GetDayOfWeek(), 0, 0, 0);
	CTimeSpan taDay(1, 0, 0, 0);
	CString strDate;
	// 
	CoInitialize(NULL);
	m_arrDateandUrl.RemoveAll();
	m_arrTitle.RemoveAll();
	m_arrHandle.RemoveAll();

	HRESULT hr	  = CoCreateInstance(CLSID_CUrlHistory, NULL, CLSCTX_INPROC_SERVER, IID_IUrlHistoryStg2, reinterpret_cast<void **>(&pHistory));
	ULONG	celt  = 0;
	int 	index = 1;

	if (SUCCEEDED(hr)) {
		pHistory->EnumUrls(&URLs);
		while (URLs->Next(index, &url, &celt) == S_OK) {
			// t̎擾& xTԂ̐U蕪
			m_Date = url.ftLastVisited;
			if (m_Date + tWeek1 >= tNow) {
				strDate = m_Date.Format( _T("%Y/%m/%d") ) + _T(" ");
			} else if (m_Date + tWeek2 >= tNow) {
				strDate= _T("13  1 week ");
			} else if (m_Date + tWeek3 >= tNow) {
				strDate= _T("12  2 week ");
			} else {
				strDate= _T("11  3 week ");
			}
			// f[^
			m_arrDateandUrl.Add(strDate + url.pwcsUrl);
			if (!url.pwcsTitle) {
				strDate = url.pwcsUrl;
				strDate = strDate.Mid(strDate.ReverseFind('/') +1);
				//strDate = strDate.Right(strDate.GetLength()- strDate.ReverseFind('/') -1);
				m_arrTitle.Add(strDate);
			} else {
				m_arrTitle.Add(url.pwcsTitle);
			}
			// ^Cg@@@@ url.pwcsTitle
			// TCgɂ url.ftLastVisited
			// TCgURL @@ url.pwcsUrl
			index++;
		}
		URLs->Release();
	}
	hr = pHistory->Release();
	CoUninitialize();

	SortHistory(0, int( m_arrDateandUrl.GetSize() - 1));//\[g
	m_arrHandle.SetSize(m_arrTitle.GetSize());
}

/// tɃ[h
void CSidebarHistory::LoadHistory2()
{
	// XTԑO
	CString 	strDate;
	// 
	m_arrDateandUrl.RemoveAll();
	m_arrTitle.RemoveAll();
	m_arrHandle.RemoveAll();

	// IuWFNg쐬
	CComPtr<IUrlHistoryStg2> spHistory;
	HRESULT hr = spHistory.CoCreateInstance(CLSID_CUrlHistory, NULL, CLSCTX_INPROC_SERVER);
	if (SUCCEEDED(hr)) {
		// URL擾
		CComPtr<IEnumSTATURL> spURLs;
		spHistory->EnumUrls(&spURLs);

		// http݂̂tB^O
		LPCOLESTR lpFilter = OLESTR("http");
		spURLs->SetFilter(lpFilter, STATURLFLAG_ISTOPLEVEL);

		int 	 index = 1;
		_STATURL url;
		ULONG	 celt = 0;
		while (spURLs->Next(index, &url, &celt) == S_OK) {
			// t̎擾& xTԂ̐U蕪
			CTime	m_Date(url.ftLastVisited);
			strDate = m_Date.Format( _T("%Y/%m/%d %H:%M:%S") ) + _T(" ");
			// f[^
			m_arrDateandUrl.Add(strDate + url.pwcsUrl);
			if (!url.pwcsTitle) {
				strDate = url.pwcsUrl;
				strDate = strDate.Mid(strDate.ReverseFind(_T('/')) + 1);
				m_arrTitle.Add(strDate);
			} else {
				m_arrTitle.Add(url.pwcsTitle);
			}
			// ^Cg@@@@ url.pwcsTitle
			// TCgɂ url.ftLastVisited
			// TCgURL @@ url.pwcsUrl
			index++;
		}
	}
	SortHistory(0, int(m_arrDateandUrl.GetSize() - 1));//\[g
	m_arrHandle.SetSize(m_arrTitle.GetSize());

	// ۂɒǉ
	LockWindowUpdate();

	DeleteAllItems();
	CString 	str;
	HTREEITEM	handle;
	int nHistoryEnd = int(m_arrDateandUrl.GetSize() - g_Options.HistorySortCount);
	if (nHistoryEnd < 0) {
		nHistoryEnd = 0;
	}

	for (int i = int(m_arrDateandUrl.GetSize() - 1); i >= nHistoryEnd; i--) {
		handle = InsertItem(m_arrTitle.GetAt(i), 6, 7, TVI_ROOT, TVI_LAST);
		m_arrHandle.SetAt(i, (void*)handle);		//+++@ cast chg.
	}

	UnlockWindowUpdate();
}

/// NCbN\[g
void CSidebarHistory::SortHistory(int left, int right)
{
	if (left >= right) {// [v甲
		return;
	}
	int i = left + 1, j = right;
	CString bufDay, bufTitle;
	CString strStandard = m_arrDateandUrl.GetAt(left);

	while (i <= j) {
		while (i <= j) {
			if (m_arrDateandUrl.GetAt(i).CompareNoCase(strStandard) > 0) {
				break;
			}
			i++;
		}
		while (i<=j) {
			if (m_arrDateandUrl.GetAt(j).CompareNoCase(strStandard) < 0) {
				break;
			}
			j--;
		}
		if (i >= j) {
			break;
		}
		// swap
		bufDay	 = m_arrDateandUrl.GetAt(j);
		bufTitle = m_arrTitle.GetAt(j);
		m_arrDateandUrl.SetAt(j, m_arrDateandUrl.GetAt(i));
		m_arrTitle.SetAt(j, m_arrTitle.GetAt(i));
		m_arrDateandUrl.SetAt(i, bufDay);
		m_arrTitle.SetAt(i, bufTitle);

		i++;
		j--;
	}

	bufDay	 = m_arrDateandUrl.GetAt(j);
	bufTitle = m_arrTitle.GetAt(j);
	m_arrDateandUrl.SetAt(j, m_arrDateandUrl.GetAt(left));
	m_arrTitle.SetAt(j, m_arrTitle.GetAt(left));
	m_arrDateandUrl.SetAt(left, bufDay);
	m_arrTitle.SetAt(left, bufTitle);

	SortHistory(left, j - 1);
	SortHistory(j + 1, right);
}

/// J
void CSidebarHistory::OpenFile(BOOL bNewWindow)
{
	HTREEITEM SelectedItem = GetSelectedItem();
	//+++@ UINT index = reinterpret_cast<UINT>( SelectedItem ); 		//+++@ SelectedItem̂܂܎g.
	if (ItemHasChildren(SelectedItem)) {
		return;
	}

	if (GetItemText(SelectedItem)== _T("NbNœǂݍ") ) {
		SetItemText( SelectedItem, _T("ǂݍł܂...") );
		RedrawWindow();
		LoadHistory2();
		return;
	}

	CString strPath;
	for (int i = 0; i < m_arrHandle.GetSize(); i++) {
		if (m_arrHandle.GetAt(i) == (void*)SelectedItem/*index*/) {		//+++@ ڔr.
			strPath = m_arrDateandUrl.GetAt(i).Right(m_arrDateandUrl.GetAt(i).GetLength() - 11);
			if (g_Options.HistorySortDate) {
				strPath = strPath.Mid(9);
				//strPath = strPath.Right(strPath.GetLength() - 9);
			}
			break;
		}
	}

	if (strPath== _T("")) {
		return;
	}
	CMDIFrameWnd* pMainFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	CHtmlView2* pView = NULL;
	if (!bNewWindow && pMainFrame->MDIGetActive()) {
		// ݂̃EBhE
		pView = static_cast<CHtmlView2*>( pMainFrame->MDIGetActive()->GetActiveView() );
	} else{
		// VEBhE
		CPatriotApp* pApp = static_cast<CPatriotApp*>( AfxGetApp() );
		pView = pApp->NewTab(1, g_Options.bATHistory);
	}
	if (pView) {
		pView->Navigate(strPath);
	}
	SetFocus();
}

/////////////////////////////////////////////////////////////////////////////
// CSidebarHistory bZ[W nh

/// ACe̓WJ
void CSidebarHistory::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult)
{
	if (!m_bLoaded){
		//ǂݍ
		LoadHistory();
		m_bLoaded = TRUE;
	}

	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	if (GetItemText(GetChildItem(pNMTreeView->itemNew.hItem))!= _T("no child") ) {
		return;
	}
	// \z
	AddFolder();
	DeleteItem( GetChildItem(pNMTreeView->itemNew.hItem) );
	SortChildren( GetSelectedItem() );
	*pResult = 0;
}

/// ڂ̕\
void CSidebarHistory::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult)
{
	BOOL bNewWindow = (GetKeyState(VK_SHIFT) & 0x8000) ? !g_Options.bNWHistory : g_Options.bNWHistory;
	OpenFile(bNewWindow);
	*pResult = 0;
}

///
void CSidebarHistory::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	*pResult = 0;
	HTREEITEM	itemNow    = pNMTreeView->itemNew.hItem;
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();

	if (ItemHasChildren(itemNow)) {
		return;
	}
	// Xe[^Xo[ URL \
	//+++@ UINT index = (DWORD)itemNow;
	CString 	strPath;
	for (int i = 0; i < m_arrHandle.GetSize(); i++) {
		if (m_arrHandle.GetAt(i) == (void*)itemNow/*index*/) {	//+++@ itemNoŵ܂ܔr.
			strPath = m_arrDateandUrl.GetAt(i).Right(m_arrDateandUrl.GetAt(i).GetLength()-11);
			break;
		}
	}
	pMainFrame->SetMessageText( strPath );

	if (pNMTreeView->action ==TVC_BYMOUSE) { // I̕ύX
		OpenFile((GetKeyState(VK_SHIFT) & 0x8000) ? !g_Options.bNWHistory : g_Options.bNWHistory);
	}
}

/// ENbNj[
void CSidebarHistory::OnContextMenu(CWnd* pWnd, CPoint point)
{
	POINT posClient = point;
	ScreenToClient(&posClient);

	m_ClickedItem = HitTest(posClient);
	if (!m_ClickedItem) {
		return;
	}
	CMenu menu;
	menu.LoadMenu(IDR_SIDEBAR);
	CMenu* pPopup = menu.GetSubMenu(0);

	pPopup->AppendMenu(MF_STRING, ID_SIDEBAR_DATESORTMODE, _T("t\") );
	pPopup->CheckMenuItem(ID_SIDEBAR_DATESORTMODE , MF_BYCOMMAND | (g_Options.HistorySortDate) ? MF_CHECKED : MF_UNCHECKED);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, point.x, point.y, this, NULL);
	menu.DestroyMenu();
}

/// J
void CSidebarHistory::OnSidebarOpen()
{
	OpenFile(FALSE);
}

/// VEBhEŊJ
void CSidebarHistory::OnSidebarOpennew()
{
	OpenFile(TRUE);
}

/// XV
void CSidebarHistory::OnSidebarRefreshall()
{
	LockWindowUpdate();

	// 
	DeleteAllItems();
	m_arrDateandUrl.RemoveAll();
	m_arrTitle.RemoveAll();
	m_arrHandle.RemoveAll();

	// ǂݍ
	m_bLoaded = FALSE;
	if (g_Options.HistorySortDate) {
		LoadHistory2();
	} else {
		LoadWeekly();
	}

	UnlockWindowUpdate();
}

/// t
void CSidebarHistory::OnSidebarDatesortmode()
{
	g_Options.HistorySortDate = !g_Options.HistorySortDate;
	OnSidebarRefreshall();
}

/// PreTranslateMessage
BOOL CSidebarHistory::PreTranslateMessage(MSG* pMsg)
{
	if ( pMsg->message == WM_KEYDOWN) {
		switch(pMsg->wParam){
		case VK_RETURN:
			OpenFile(g_Options.bNWHistory);
			break;
		}
	}
	return CTreeCtrl::PreTranslateMessage(pMsg);
}
