//////////////////////////////////////////////////////////////////////
// UrllistFile.h: URLXg̓ǂݏNX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "StdAfx.h"
#include "HtmlView2.h"
#include <afxtempl.h>

class CTravelLogEntry;
class CUrllistFile;

class CUrllistItem
{
public:
	CString 		 strURL;
	CString 		 strTitle;
	CString 		 strSetting;

private:
	friend class CUrllistFile;
	CTravelLogEntry* m_pBackEntries;
	CTravelLogEntry* m_pForwardEntries;

public:
	/// RXgN^	//+++ inlineɕύX.
	CUrllistItem() : m_pBackEntries(0), m_pForwardEntries(0) {}
  #if 1	//+++ o[ݒ̃RXgN^ǉ.
	CUrllistItem(const CString& url, const CString& ttl, LPCTSTR pSet)
		: strURL(url), strTitle(ttl), strSetting(pSet), m_pBackEntries(0), m_pForwardEntries(0)
	{}
  #endif
	/// fXgN^
	~CUrllistItem();

	/// ^uJ
	void Open(BOOL bNewWindow = TRUE, BOOL bActive = FALSE, BOOL bAddLast = TRUE);
	/// ^u̐ݒ擾
	void Get( CHtmlView2* pView );
	/// ^u̐ݒXV
	void Set( CHtmlView2* pView );
};

class CUrllistFile : public CArray< CUrllistItem*, CUrllistItem* >
{
public:
	CUrllistFile();
	~CUrllistFile();

	///
	BOOL Load( CString strFileName = _T("") );
	///
	BOOL Save( CString strFileName = _T("") );
	///
	static BOOL Open( CString strFileName );
	///
	void Destroy();
	///
	int  AddView( CHtmlView2* pView );

protected:
	CString 	m_strFileName;
};
