// PageMouse.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageMouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageMouse vpeB y[W

IMPLEMENT_DYNCREATE(CPageMouse, CPropertyPage)

/// ftHgERXgN^
CPageMouse::CPageMouse() : CPropertyPage(CPageMouse::IDD)
{
	//{{AFX_DATA_INIT(CPageMouse)
	m_UseContext		= FALSE;
	m_DefaultContext	= FALSE;
	m_MouseViewDnD		= FALSE;	//+++
	m_RClick			= -1;
	m_DBClick			= -1;
	m_WClick			= -1;
	m_LRClick			= -1;
	m_sLClick			= -1;
	m_sWClick			= -1;
	m_sRClick			= -1;
	m_TabWheel			= FALSE;
	m_SelectedContext	= FALSE;
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageMouse::~CPageMouse()
{
}

///
void CPageMouse::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageMouse)
	DDX_Check(pDX, IDC_CHECK1, m_UseContext);
	DDX_Check(pDX, IDC_CHECK2, m_DefaultContext);
	DDX_Check(pDX, IDC_CHECK_VIEW_DND, m_MouseViewDnD);		//+++
	DDX_CBIndex(pDX, IDC_COMBO2, m_RClick);
	DDX_CBIndex(pDX, IDC_COMBO3, m_DBClick);
	DDX_CBIndex(pDX, IDC_COMBO4, m_WClick);
	DDX_CBIndex(pDX, IDC_COMBO5, m_LRClick);
	DDX_CBIndex(pDX, IDC_COMBO6, m_sLClick);
	DDX_CBIndex(pDX, IDC_COMBO7, m_sWClick);
	DDX_CBIndex(pDX, IDC_COMBO8, m_sRClick);
	DDX_Check(pDX, IDC_CHECK3, m_TabWheel);
	DDX_Check(pDX, IDC_CHECK4, m_SelectedContext);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageMouse, CPropertyPage)
	//{{AFX_MSG_MAP(CPageMouse)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageMouse bZ[W nh

/// _CAO
BOOL CPageMouse::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// ݒǂݍ
	// }EX
	m_UseContext		= g_Options.MouseUseContext;
	m_DefaultContext	= g_Options.MouseDefaultContext;
	m_SelectedContext	= g_Options.MouseSelectedContext;
	m_MouseViewDnD		= g_Options.MouseViewDnD;			//+++
	m_TabWheel			= g_Options.MouseTabWheel;
	m_RClick			= g_Options.TabRtClick;
	m_DBClick			= g_Options.TabDbClick;
	m_WClick			= g_Options.TabWlClick;
	m_LRClick			= g_Options.TabLrClick;
	m_sLClick			= g_Options.TabSlClick;
	m_sWClick			= g_Options.TabSwClick;
	m_sRClick			= g_Options.TabSrClick;
	if (!m_UseContext)
		OnCheck1();
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageMouse::OnOK()
{
	// }EX
	g_Options.MouseUseContext		= m_UseContext;
	g_Options.MouseDefaultContext	= m_DefaultContext;
	g_Options.MouseSelectedContext	= m_SelectedContext;
	g_Options.MouseViewDnD			= m_MouseViewDnD;	//+++
	g_Options.MouseTabWheel 		= m_TabWheel;
	g_Options.TabRtClick			= m_RClick;
	g_Options.TabDbClick			= m_DBClick;
	g_Options.TabWlClick			= m_WClick;
	g_Options.TabLrClick			= m_LRClick;
	g_Options.TabSlClick			= m_sLClick;
	g_Options.TabSwClick			= m_sWClick;
	g_Options.TabSrClick			= m_sRClick;
	CPropertyPage::OnOK();
}

/// ƎENbN悤
void CPageMouse::OnCheck1()
{
	BOOL bCheck = ((CButton*)GetDlgItem(IDC_CHECK1))->GetCheck();

	GetDlgItem(IDC_CHECK2)->EnableWindow(bCheck);
	GetDlgItem(IDC_CHECK4)->EnableWindow(bCheck);
}
