// PagePopup.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PagePopup.h"
#include "../patriotGlobal2.h"
#include "../InputBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPagePopup vpeB y[W

IMPLEMENT_DYNCREATE(CPagePopup, CPropertyPage)

/// ftHgERXgN^
CPagePopup::CPagePopup()
	: CPropertyPage(CPagePopup::IDD)
	, m_List()
{
	//{{AFX_DATA_INIT(CPagePopup)
	m_Use = FALSE;
	//}}AFX_DATA_INIT
}

/// fXgN^
CPagePopup::~CPagePopup()
{
}

///
void CPagePopup::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPagePopup)
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Check(pDX, IDC_CHECK1, m_Use);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPagePopup, CPropertyPage)
	//{{AFX_MSG_MAP(CPagePopup)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, OnDblclkList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPagePopup bZ[W nh

/// _CAO
BOOL CPagePopup::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// XgRg[
	m_List.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_List.InsertColumn( 0, _T("URL"),		NULL, 320 );
	m_List.InsertColumn( 1, _T("}~"), NULL,  62 );

	// }Xgǉ
	INT_PTR nSize = g_Options.arrContentFilter.GetSize();		//+++@
	for (int i = 0; i < nSize; i++) {
		CString strURL = g_Options.arrContentFilter.GetAt(i);
		CString strCount = ItoStr( g_Options.arrContentFilterCounts.GetAt(i) );

		m_List.InsertItem( i, strURL );
		m_List.SetItemText( i, 1, strCount );
	}

	if ( m_List.GetItemCount() > 0 ) {
		m_List.SetItemState( 0, 2, LVIS_SELECTED );
	} else {
		GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
	}

	// ݒǂݍ
	m_Use = g_Options.bContentBlockUse;

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPagePopup::OnOK()
{
	//+++ CStdioFile fin( g_Options.strOptionPath + _T("\\contentblock.dat"), CFile::modeCreate | CFile::modeWrite );
	CWriteTextFile fin( g_Options.strOptionPath + _T("\\contentblock.dat"), CFile::modeCreate | CFile::modeWrite );
	CString str;

	int nCount = m_List.GetItemCount();
	for (int i = 0; i < nCount; i++) {
		str = m_List.GetItemText(i, 0) + _T("\t") + m_List.GetItemText(i, 1) + _T("\n");
		fin.WriteString(str);
	}
	fin.Close();

	// ݒۑ
	g_Options.bContentBlockUse = m_Use;

	CPropertyPage::OnOK();
}

/// ǉ
void CPagePopup::OnButton1()
{
	CInputBox dlg;
	CString strURL = dlg.GetInput( _T("RecubN"), _T("ubNURL͂ĂB"), _T("http://") );
	if (!strURL.IsEmpty()) {
		int nCount = m_List.GetItemCount();
		m_List.InsertItem( nCount, strURL );
		m_List.SetItemText( nCount, 1, _T("0") );
	}

	GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
}

/// 폜
void CPagePopup::OnButton2()
{
	POSITION pos = m_List.GetFirstSelectedItemPosition();
	int index = m_List.GetNextSelectedItem(pos);
	if (index == -1) {
		return;
	}

	m_List.DeleteItem(index);

	if (m_List.GetItemCount() > 0) {
		// CfbNX蓖
		if (m_List.GetItemCount() <= index) {
			m_List.SetItemState(m_List.GetItemCount() - 1, 2, LVIS_SELECTED);
		} else {
			m_List.SetItemState(index, 2, LVIS_SELECTED);
		}
	}
}

/// }~񐔂Zbg
void CPagePopup::OnButton3()
{
	int nCount = m_List.GetItemCount();
	for (int i = 0; i < nCount; i++) {
		m_List.SetItemText( i, 1, _T("0") );
	}
}

/// Xg_uNbN
void CPagePopup::OnDblclkList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	POSITION pos = m_List.GetFirstSelectedItemPosition();
	int index = m_List.GetNextSelectedItem(pos);
	if (index == -1) {
		return;
	}

	CString strURL = m_List.GetItemText(index, 0);

	CInputBox dlg;
	strURL = dlg.GetInput( _T("RecubN"), _T("VURL͂ĂB"), strURL );
	if (!strURL.IsEmpty()) {
		m_List.SetItemText(index, 0, strURL);
	}

	*pResult = 0;
}
