// PageSecurity.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageSecurity.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageSecurity vpeB y[W

IMPLEMENT_DYNCREATE(CPageSecurity, CPropertyPage)

/// ftHgERXgN^
CPageSecurity::CPageSecurity() : CPropertyPage(CPageSecurity::IDD)
{
	//{{AFX_DATA_INIT(CPageSecurity)
	m_Cookie			= FALSE;
	m_Img				= FALSE;
	m_Bgm				= FALSE;
	m_Video 			= FALSE;
	m_Script			= FALSE;
	m_Java				= FALSE;
	m_ActivexR			= FALSE;
	m_ActivexD			= FALSE;
	m_Silent			= FALSE;
	m_Antipopup 		= FALSE;
	m_Cookie2			= FALSE;
	m_RefreshSecurity	= FALSE;
	m_NavigateLock		= FALSE;
	m_TabLock			= FALSE;
	m_AsNavigateLock	= FALSE;
	m_TablockWhenShift	= FALSE;
	m_SucceedSecurity	= FALSE;
	m_CookieIE6 		= -1;
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageSecurity::~CPageSecurity()
{
}

///
void CPageSecurity::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageSecurity)
	DDX_Check(pDX, IDC_CHECK1, m_Cookie);
	DDX_Check(pDX, IDC_CHECK2, m_Cookie2);
	DDX_Check(pDX, IDC_CHECK3, m_Img);
	DDX_Check(pDX, IDC_CHECK4, m_Bgm);
	DDX_Check(pDX, IDC_CHECK5, m_Video);
	DDX_Check(pDX, IDC_CHECK6, m_Script);
	DDX_Check(pDX, IDC_CHECK7, m_Java);
	DDX_Check(pDX, IDC_CHECK9, m_ActivexR);
	DDX_Check(pDX, IDC_CHECK8, m_ActivexD);
	DDX_Check(pDX, IDC_CHECK10, m_Silent);
	DDX_Check(pDX, IDC_CHECK11, m_Antipopup);
	DDX_Check(pDX, IDC_CHECK12, m_RefreshSecurity);
	DDX_Check(pDX, IDC_CHECK13, m_NavigateLock);
	DDX_Check(pDX, IDC_CHECK14, m_TabLock);
	DDX_Check(pDX, IDC_CHECK15, m_SucceedSecurity);
	DDX_Check(pDX, IDC_CHECK16, m_AsNavigateLock);
	DDX_Check(pDX, IDC_CHECK17, m_TablockWhenShift);
	DDX_CBIndex(pDX, IDC_COMBO1, m_CookieIE6);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageSecurity, CPropertyPage)
	//{{AFX_MSG_MAP(CPageSecurity)
		// : ClassWizard ͂̈ʒu DDX  DDV ̌ĂяoR[hǉ܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageSecurity bZ[W nh

/// _CAO
BOOL CPageSecurity::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// ݒǂݍ
	// ZLeB
	m_Img				= g_Options.defoLoadImage;
	m_Bgm				= g_Options.defoLoadBgm;
	m_Video 			= g_Options.defoLoadVideo;
	m_Script			= g_Options.defoRunScript;
	m_Java				= g_Options.defoRunJava;
	m_ActivexR			= g_Options.defoRunActivex;
	m_ActivexD			= g_Options.defoLoadActivex;
	m_Antipopup 		= g_Options.defoAntiPopup;
	m_NavigateLock		= g_Options.defoNavigateLock;
	m_TabLock			= g_Options.defoTabLock;
	m_Silent			= g_Options.defoSilent;
	m_Cookie			= g_Options.defoCookie;
	m_Cookie2			= g_Options.defoCookieSession;
	m_CookieIE6 		= g_Options.bCookieIe6;

	m_SucceedSecurity	= g_Options.SecuritySucceed;
	m_RefreshSecurity	= g_Options.SecurityRefresh;
	m_AsNavigateLock	= g_Options.bAsNavigateLock;
	m_TablockWhenShift	= g_Options.bTablockWhenShift;

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageSecurity::OnOK()
{
	// ZLeB
	g_Options.defoLoadImage 	= m_Img;
	g_Options.defoLoadBgm		= m_Bgm;
	g_Options.defoLoadVideo 	= m_Video;
	g_Options.defoRunScript 	= m_Script;
	g_Options.defoRunJava		= m_Java;
	g_Options.defoRunActivex	= m_ActivexR;
	g_Options.defoLoadActivex	= m_ActivexD;
	g_Options.defoAntiPopup 	= m_Antipopup;
	g_Options.defoSilent		= m_Silent;
	g_Options.defoCookie		= m_Cookie;
	g_Options.defoCookieSession = m_Cookie2;
	g_Options.defoNavigateLock	= m_NavigateLock;
	g_Options.defoTabLock		= m_TabLock;
	g_Options.SecurityRefresh	= m_RefreshSecurity;
	g_Options.bCookieIe6		= m_CookieIE6;
	g_Options.SecuritySucceed	= m_SucceedSecurity;
	g_Options.SecurityRefresh	= m_RefreshSecurity;
	g_Options.bAsNavigateLock	= m_AsNavigateLock;
	g_Options.bTablockWhenShift = m_TablockWhenShift;
	CPropertyPage::OnOK();
}
