// PageTab.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageTab vpeB y[W

IMPLEMENT_DYNCREATE(CPageTab, CPropertyPage)

/// ftHgERXgN^
CPageTab::CPageTab()
	: CPropertyPage(CPageTab::IDD)
	, m_CurFont(0)
	, m_CurBack(0)
	, m_nCurFont(0)
	, m_nCurBack(0)
	, m_SelFont()
	, m_UnselFont()
	, m_strFontName()
	, m_FontSize(0)
{
	//{{AFX_DATA_INIT(CPageTab)
	m_Button		= FALSE;
	m_Multi 		= FALSE;
	m_Under 		= FALSE;
	m_Img			= FALSE;
	m_ImgNomal		= FALSE;
	m_Width 		= 0;
	m_WidthTitle	= 0;
	m_CurB			= FALSE;
	m_CurU			= FALSE;
	m_CurI			= FALSE;
	m_nCurB 		= FALSE;
	m_nCurU 		= FALSE;
	m_nCurI 		= FALSE;
	m_WidthTitleMin = 0;
	m_TabMax		= 0;
	m_ImgTablock	= FALSE;
	m_Loop			= FALSE;
	m_Wheel 		= FALSE;
	m_Add			= -1;
	m_Delete		= -1;
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageTab::~CPageTab()
{
}

///
void CPageTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageTab)
	DDX_Check(pDX, IDC_CHECK1, m_Button);
	DDX_Check(pDX, IDC_CHECK5, m_Multi);
	DDX_Check(pDX, IDC_CHECK2, m_Under);
	DDX_Check(pDX, IDC_CHECK3, m_Img);
	DDX_Check(pDX, IDC_CHECK4, m_ImgNomal);
	DDX_Text(pDX, IDC_EDIT1, m_Width);
	DDV_MinMaxUInt(pDX, m_Width, 0, 255);
	DDX_Text(pDX, IDC_EDIT2, m_WidthTitle);
	DDV_MinMaxUInt(pDX, m_WidthTitle, 0, 255);
	DDX_Check(pDX, IDC_CHECK6, m_CurB);
	DDX_Check(pDX, IDC_CHECK7, m_CurU);
	DDX_Check(pDX, IDC_CHECK8, m_CurI);
	DDX_Check(pDX, IDC_CHECK10, m_nCurB);
	DDX_Check(pDX, IDC_CHECK11, m_nCurU);
	DDX_Check(pDX, IDC_CHECK12, m_nCurI);
	DDX_Text(pDX, IDC_EDIT3, m_WidthTitleMin);
	DDV_MinMaxUInt(pDX, m_WidthTitleMin, 0, 255);
	DDX_Text(pDX, IDC_EDIT4, m_TabMax);
	DDV_MinMaxUInt(pDX, m_TabMax, 0, 1000);
	DDX_Check(pDX, IDC_CHECK9, m_ImgTablock);
	DDX_Check(pDX, IDC_CHECK14, m_Loop);
	DDX_Check(pDX, IDC_CHECK13, m_Wheel);
	DDX_CBIndex(pDX, IDC_COMBO1, m_Add);
	DDX_CBIndex(pDX, IDC_COMBO2, m_Delete);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageTab, CPropertyPage)
	//{{AFX_MSG_MAP(CPageTab)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_CHECK6 , OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7 , OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8 , OnCheck8)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck12)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageTab bZ[W nh

/// _CAO
BOOL CPageTab::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// ݒǂݍ
	// ^u
	m_Button	=g_Options.TabButton;
	m_Multi 	=g_Options.TabMulti;
	m_Under 	=g_Options.TabUnder;
	m_Img		=g_Options.TabImg;
	m_ImgNomal	=g_Options.TabImgNomal;
	m_ImgTablock = g_Options.TabImgTablock;

	m_TabMax		=g_Options.TabMax;
	m_Width 		=g_Options.TabWidth;
	m_WidthTitle	=g_Options.TabTitleWidth;
	m_WidthTitleMin =g_Options.TabTitleWidthMin;

	m_CurFont 	=g_Options.TabSelFontColor;
	m_CurBack 	=g_Options.TabSelBackColor;
	m_CurB		=g_Options.TabSelFontB;
	m_CurI		=g_Options.TabSelFontI;
	m_CurU		=g_Options.TabSelFontU;
	m_nCurFont	=g_Options.TabFontColor;
	m_nCurBack	=g_Options.TabBackColor;
	m_nCurB 	=g_Options.TabFontB;
	m_nCurI 	=g_Options.TabFontI;
	m_nCurU 	=g_Options.TabFontU;

	m_Wheel 	=g_Options.TabUseWheel;
	m_Loop		=g_Options.TabLoop;
	m_Add		=g_Options.TabPosAdd;
	m_Delete	=g_Options.TabPosDel;

	m_strFontName	=AfxGetApp()->GetProfileString( _T("Tab") , _T("FontFace"), _T("MS UI Gothic") );
	m_FontSize		=AfxGetApp()->GetProfileInt( _T("Tab") , _T("FontSize") , 10);

	UpdateData(FALSE);
	RefreshSample();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageTab::OnOK()
{
	// ^u
	g_Options.TabButton 	=m_Button;
	g_Options.TabMulti		=m_Multi;
	g_Options.TabUnder		=m_Under;
	g_Options.TabImg		=m_Img;
	g_Options.TabImgNomal	=m_ImgNomal;
	g_Options.TabImgTablock =m_ImgTablock;

	g_Options.TabMax			=m_TabMax;
	g_Options.TabWidth			=m_Width;
	g_Options.TabTitleWidth 	=m_WidthTitle;
	g_Options.TabTitleWidthMin	=m_WidthTitleMin;

	g_Options.TabSelFontColor	=m_CurFont;
	g_Options.TabSelBackColor	=m_CurBack;
	g_Options.TabSelFontB		=m_CurB;
	g_Options.TabSelFontI		=m_CurI;
	g_Options.TabSelFontU		=m_CurU;
	g_Options.TabFontColor		=m_nCurFont;
	g_Options.TabBackColor		=m_nCurBack;
	g_Options.TabFontB			=m_nCurB;
	g_Options.TabFontI			=m_nCurI;
	g_Options.TabFontU			=m_nCurU;

	g_Options.TabLoop		=m_Loop;
	g_Options.TabUseWheel	=m_Wheel;
	g_Options.TabPosAdd 	=m_Add;
	g_Options.TabPosDel 	=m_Delete;

	AfxGetApp()->WriteProfileString( _T("Tab") , _T("FontFace") , m_strFontName);
	AfxGetApp()->WriteProfileInt( _T("Tab") , _T("FontSize") , m_FontSize);

	CPropertyPage::OnOK();
}

/// F擾
COLORREF CPageTab::GetColor(COLORREF colorDefault)
{
	CColorDialog dlg(colorDefault, CC_RGBINIT | CC_FULLOPEN, this);
	if (dlg.DoModal() == IDCANCEL) {
		return -1;
	}
	return dlg.GetColor();
}

/// Tvĕ`
void CPageTab::RefreshSample()
{
	CSize size;
	// w肵傫̃tHg쐬
	CClientDC dc(this);
	CFont font;
	font.DeleteObject();	// U폜
	font.CreatePointFont(m_FontSize*10 , m_strFontName , NULL);

	CWnd* pStatic1 = GetDlgItem(IDC_STATIC1);
	CWnd* pStatic2 = GetDlgItem(IDC_STATIC2);

	m_SelFont.DeleteObject();
	m_UnselFont.DeleteObject();
	// Get the current font
	LOGFONT lFont;
	if (&font)
		font.GetLogFont(&lFont);
	else{
		NONCLIENTMETRICS ncm;
		ncm.cbSize = sizeof(NONCLIENTMETRICS);
		VERIFY(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0));
		lFont = ncm.lfMessageFont;
	}
	// Create the  _T("Selected")  font
	lFont.lfWeight = (m_CurB) ? FW_BOLD : FW_NORMAL;
	lFont.lfItalic = m_CurI;
	lFont.lfUnderline = m_CurU;
	m_SelFont.CreateFontIndirect(&lFont);
	pStatic1->SetFont(&m_SelFont);
	// Create the  _T("Unselected")  font
	lFont.lfWeight = (m_nCurB == TRUE) ? FW_BOLD : FW_NORMAL;
	lFont.lfItalic = m_nCurI;
	lFont.lfUnderline = m_nCurU;
	m_UnselFont.CreateFontIndirect(&lFont);
	pStatic2->SetFont(&m_UnselFont);

	OnPaint();
}

/// `
void CPageTab::OnPaint()
{
	CPaintDC dc(this);
	CRect rect;

	CWnd* pwndStaticActive = GetDlgItem(IDC_STATIC1);
	CDC* pDC1 = pwndStaticActive->GetDC();
	pDC1->SelectObject(&m_SelFont);
	pDC1->SetTextColor(m_CurFont);
	pwndStaticActive->GetClientRect(rect);
	rect.DeflateRect(1,1);
	pDC1->FillSolidRect(rect, m_CurBack);
	pDC1->DrawText(_T("ANeBuȃ^u"), rect, DT_SINGLELINE | DT_VCENTER | DT_CENTER);
	pwndStaticActive->ReleaseDC(pDC1);


	CWnd* pwndStaticNormal = GetDlgItem(IDC_STATIC2);
	CDC* pDC2 = pwndStaticNormal->GetDC();
	pDC2->SelectObject(&m_UnselFont);
	pDC2->SetTextColor(m_nCurFont);
	pwndStaticNormal->GetClientRect(rect);
	rect.DeflateRect(1,1);
	pDC2->FillSolidRect(rect, m_nCurBack);
	pDC2->DrawText(_T("ANeBułȂ^u"), rect, DT_SINGLELINE | DT_VCENTER | DT_CENTER);
	pwndStaticNormal->ReleaseDC(pDC2);
}

/// ANeBuF
void CPageTab::OnButton1()
{
	COLORREF colorNew = GetColor(m_CurFont);
	if (colorNew >= 0) {
		m_CurFont = colorNew;
		RefreshSample();
	}
}

/// ANeBuwiF
void CPageTab::OnButton2()
{
	COLORREF colorNew = GetColor(m_CurBack);
	if (colorNew >= 0) {
		m_CurBack = colorNew;
		RefreshSample();
	}
}

/// ANeBuF
void CPageTab::OnButton3()
{
	COLORREF colorNew = GetColor(m_nCurFont);
	if (colorNew >= 0) {
		m_nCurFont = colorNew;
		RefreshSample();
	}
}

/// ANeBuwiF
void CPageTab::OnButton4()
{
	COLORREF colorNew = GetColor(m_nCurBack);
	if (colorNew >= 0) {
		m_nCurBack = colorNew;
		RefreshSample();
	}
}

/// tHg
void CPageTab::OnButton5()
{
	CFontDialog dlg;

	dlg.m_cf.Flags|=CF_INITTOLOGFONTSTRUCT;
	lstrcpyn(dlg.m_cf.lpLogFont->lfFaceName, (LPCTSTR)m_strFontName, LF_FACESIZE);
	dlg.m_cf.iPointSize = m_FontSize*10;
	if (dlg.DoModal() == IDCANCEL)
		return;
	m_strFontName	=dlg.GetFaceName();
	m_FontSize		=dlg.GetSize()/10;
	RefreshSample();
}

/// Zbg
void CPageTab::OnButton6()
{
	UpdateData(TRUE);
	m_CurFont 	=GetSysColor(COLOR_HOTLIGHT);
	m_CurBack 	=GetSysColor(COLOR_BTNFACE);
	m_CurB		=FALSE;
	m_CurI		=FALSE;
	m_CurU		=FALSE;
	m_nCurFont	=GetSysColor(COLOR_BTNTEXT);
	m_nCurBack	=GetSysColor(COLOR_BTNFACE);
	m_nCurB 	=FALSE;
	m_nCurI 	=FALSE;
	m_nCurU 	=FALSE;
	UpdateData(FALSE);
	RefreshSample();
}


void CPageTab::OnCheck6() {UpdateData(TRUE);RefreshSample();}	///<
void CPageTab::OnCheck7() {UpdateData(TRUE);RefreshSample();}	///<
void CPageTab::OnCheck8() {UpdateData(TRUE);RefreshSample();}	///<
void CPageTab::OnCheck10(){UpdateData(TRUE);RefreshSample();}	///<
void CPageTab::OnCheck11(){UpdateData(TRUE);RefreshSample();}	///<
void CPageTab::OnCheck12(){UpdateData(TRUE);RefreshSample();}	///<

