// patriotView.h : CPatriotView NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PATRIOTVIEW_H__2678F54E_D704_11D5_8799_E58356340A34__INCLUDED_)

#include "TabsCollection.h"
#include "HtmlViewExSite.h"
#include "FiltersCollection.h"
#include "SpatialNavigation.h"

//#include "DropTarget.h"			//+++
#include "HtmlViewDropTarget.h"		//+++ ǉ.


#define AFX_PATRIOTVIEW_H__2678F54E_D704_11D5_8799_E58356340A34__INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif
#include <afxhtml.h>
#include "HtmlView2.h"

class CPatriotDoc;
class CTravelLogManager;

class CPatriotView : public CHtmlView2
{
protected: // VACY@\݂̂쐬܂B
	CPatriotView();
	DECLARE_DYNCREATE(CPatriotView)

// Agr[g
private:
	int 		m_TabIndex;
	int 		m_nSSL;
	BOOL		m_bPrivacyImpacted;
	BOOL		m_bBusy;
	//+++ BOOL	m_bMozilla;			//+++ gp.
public:
	BOOL		m_bRead;
private:
	BOOL		m_bNavigateLock;
	BOOL		m_bTabLock;
public:
	BOOL		m_bBackButton;
	BOOL		m_bForwardButton;
private:
	BOOL		m_bAutoRefresh;
	//BOOL		m_bFirstNavigation;	//+++ BOOL̂܂intl͕̂ŝBYTE^ɏC.
	BYTE		m_byFirstNavigation;
	BOOL		m_bAntiPopup;
	BOOL		m_bPopupMode;

	BOOL		m_bLoadImage;
	BOOL		m_bLoadBgm;
	BOOL		m_bLoadVideo;
	BOOL		m_bLoadActivex;
	BOOL		m_bRunScript;
	BOOL		m_bRunJava;
	BOOL		m_bRunActivex;
	BOOL		m_bUseDlg;

	CString 	m_strGreaseMonkey;
	CString 	m_strHilightWord;
	CString 	m_strCssFile;

public:
	CTravelLogManager*		m_pTravelLogManager;
private:
	CSpatialNavigation 		m_SpatialNavi;

	int 		m_bufAutoRefresh;

	BOOL		m_BrowserMoved;
	BOOL		m_bClicked;
	BOOL		m_bDestroy;
	BOOL		m_bCtrl;
	BOOL		m_bCancel;
	BOOL		m_bFocusInitialized;

	CString 	m_strStatusBefore;
	CString 	m_strDocUrl;

	//+++ CDropTarget 		m_oDropTarget;	//+++ ŏ̔
	CHtmlViewDropTarget 	m_oDropTarget;	//+++ HtmlViewExSitȅ܂߂o[W.

  #if _MSC_VER >= 1300
	CHtmlViewExSite*		m_pCurChildHtmlViewExSite;
  #else
	CHtmlViewExOccManager*	m_pHtmlViewExOccManager;
  #endif

// Iy[V
public:
	CPatriotDoc* GetDocument();

  #if 1	//+++ o[ϐprivateAo[֐oRɕύX.
	int		GetTabIndex()		const { return m_TabIndex; }
	void	SetTabIndex(int n)	{ m_TabIndex = n; }

	int		GetSSL() 			const { return m_nSSL; }
	BOOL	GetPrivacyImpacted()const { return m_bPrivacyImpacted; }
	BOOL	IsBusy() 			const { return m_bBusy; }
	BOOL	GetNavigateLock()	const { return m_bNavigateLock; }
	BOOL	GetTabLock() 		const { return m_bTabLock; }
	BOOL	GetAutoRefresh() 	const { return m_bAutoRefresh; }
	BOOL	GetAntiPopup() 		const { return m_bAntiPopup; }
	BOOL	GetPopupMode() 		const { return m_bPopupMode; }
	BOOL	GetLoadImage() 		const { return m_bLoadImage; }
	BOOL	GetLoadBgm() 		const { return m_bLoadBgm; }
	BOOL	GetLoadVideo() 		const { return m_bLoadVideo; }
	BOOL	GetLoadActivex() 	const { return m_bLoadActivex; }
	BOOL	GetRunScript() 		const { return m_bRunScript; }
	BOOL	GetRunJava() 		const { return m_bRunJava; }
	BOOL	GetRunActivex()		const { return m_bRunActivex; }
	BOOL	GetUseDlg() 		const { return m_bUseDlg; }
	BOOL	HaveHilightWord()  	const { return m_strHilightWord.IsEmpty(); }
	int		GetFirstNavigation()const { return m_byFirstNavigation; }
  #endif

	void	LoadStrSetting(CString str);
	CString SaveStrSetting();

	int 	OpenURL(CString URL, BOOL NewWnd = FALSE, BOOL ActiveWnd = 2, BOOL bAddLast = FALSE);
	void	SetPageFocus();

	void	ShowPopupMenu(CPoint point, DWORD wID);
	void	LoadMenu();
	void	ExecCmd(DWORD nCmdID);
	void	RefreshMultimedia(BOOL bRefresh = TRUE);
	void	RefreshUseragent();
	void	RefreshWindow();
	BOOL	SetFocusByPos(int iCommand);

	void	ChangeErrorDlgSetting( BOOL bKillDlg );

	void	CreateTravelLogMenu(CMenu* pMenu, int flag);
	void	SendCmdOleWnd(UINT nID, WPARAM wParam = 0, LPARAM lParam = 0);

	void	SetPopupMode(BOOL bPopupMode);

	void 	SetOperateDragDrop(BOOL bOn /*, int nCommand*/);	//+++

	// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPatriotView)
	public:
	virtual void OnDraw(CDC* pDC);	// ̃r[`悷ۂɃI[o[Ch܂B
	virtual void OnTitleChange(LPCTSTR lpszText);
	virtual void OnNewWindow2(LPDISPATCH* ppDisp, BOOL* Cancel);
	virtual void OnCommandStateChange(long nCommand, BOOL bEnable);
	virtual void OnDocumentComplete(LPCTSTR lpszURL);
	virtual BOOL OnAmbientProperty(COleControlSite* pSite, DISPID dispid, VARIANT* pvar);
	virtual void OnStatusTextChange(LPCTSTR lpszText);
	virtual void OnBeforeNavigate2(LPCTSTR lpszURL, DWORD nFlags, LPCTSTR lpszTargetFrameName, CByteArray& baPostedData, LPCTSTR lpszHeaders, BOOL* pbCancel);
	virtual void OnDownloadComplete();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void OnNavigateComplete2(LPCTSTR strURL);
	virtual void OnProgressChange(long nProgress, long nProgressMax);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnInitialUpdate(); // \z̍ŏ̂PxĂяo܂B
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
  #if _MSC_VER >= 1300 //+++ vc7ȍ~MFCp
	virtual BOOL CreateControlSite(COleControlContainer* pContainer, COleControlSite** ppSite, UINT /* nID */, REFCLSID /* clsid */);	//+++ ǉ.
  #endif
	virtual HRESULT OnGetDropTarget(LPDROPTARGET pDropTarget, LPDROPTARGET* ppDropTarget);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CPatriotView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL	DoFilter(CString strUrl);
	BOOL	ApplyFilter(WebFilter* pFilter);
	BOOL	DoGreaseMonkey(LPCTSTR lpszURL);

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CPatriotView)
	afx_msg void OnDestroy();
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewStop();
	afx_msg void OnUpdateViewStop(CCmdUI* pCmdUI);
	afx_msg void OnViewBack();
	afx_msg void OnUpdateViewBack(CCmdUI* pCmdUI);
	afx_msg void OnViewForward();
	afx_msg void OnUpdateViewForward(CCmdUI* pCmdUI);
	afx_msg void OnFilePrintSetup();
	afx_msg void OnFilePrintpreview();
	afx_msg void OnFileSave();
	afx_msg void OnFileProperty();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditCopytitle();
	afx_msg void OnEditCopyurl();
	afx_msg void OnEditOpenselectedstring();
	afx_msg void OnEditOpenselectedlink();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditFind();
	afx_msg void OnViewHome();
	afx_msg void OnViewUpfolder();
	afx_msg void OnViewRefresh();
	afx_msg void OnViewSource();
	afx_msg void OnViewSourceSelected();
	afx_msg void OnToolNewwindow();
	afx_msg void OnToolLoadimage();
	afx_msg void OnToolLoadbgm();
	afx_msg void OnToolLoadmovie();
	afx_msg void OnToolRunscript();
	afx_msg void OnToolRunjava();
	afx_msg void OnToolRunactivex();
	afx_msg void OnToolLoadactivex();
	afx_msg void OnToolRunon();
	afx_msg void OnToolRunoff();
	afx_msg void OnToolInternetoption();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnFavoritesAddurllist();
	afx_msg void OnViewAutorefresh();
	afx_msg void OnFavoritesAdd();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnToolActivetab();
	afx_msg void OnUpdateToolActivetab(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolNewwindow(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolLoadimage(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolLoadbgm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolLoadmovie(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolRunscript(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolRunjava(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolRunactivex(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolLoadactivex(CCmdUI* pCmdUI);
	afx_msg void OnToolAllmediaon();
	afx_msg void OnToolAllmediaoff();
	afx_msg void OnUpdateViewAutorefresh(CCmdUI* pCmdUI);
	afx_msg void OnToolAntipopup();
	afx_msg void OnUpdateToolAntipopup(CCmdUI* pCmdUI);
	afx_msg void OnToolAddfilter();
	afx_msg void OnViewLinkback();
	afx_msg void OnViewLinknext();
	afx_msg void OnToolOffstyle();
	afx_msg void OnViewEncodeauto();
	afx_msg void OnViewEncodeeuc();
	afx_msg void OnViewEncodeiso();
	afx_msg void OnViewEncodeshiftjis();
	afx_msg void OnViewEncodeuser();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnFileNewthis();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnEditFindforward();
	afx_msg void OnEditFindback();
	afx_msg void OnEditHilight();
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnViewSecurityCertificate();
	afx_msg void OnViewPrivacyreport();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnWindowThumbnail();
	afx_msg void OnUpdateToolAddfilter(CCmdUI* pCmdUI);
	afx_msg void OnToolAddContentBlock();
	afx_msg void OnUpdateToolAddContentBlock(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolOffstyle(CCmdUI* pCmdUI);
	afx_msg void OnPopupTravellog();
	afx_msg void OnViewFocusViewTimer();
	//}}AFX_MSG

	afx_msg void OnViewBackHistory(UINT nID);
	afx_msg void OnViewForwardHistory(UINT nID);

	afx_msg void OnViewFontsize(UINT nID);
	afx_msg void OnViewFontsizeUpdate(CCmdUI* pCmdUI);

	afx_msg void OnToolSendurl(UINT nID);
	afx_msg void OnToolSendstring(UINT nID);

	afx_msg void OnViewLinkMove(UINT nID);

	afx_msg LRESULT OnChangeTabIndex(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnLoadStrSetting(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnSaveStrSetting(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnAppCommand	(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnHighlightPage (WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnFindtextPage	(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnShowContext	(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg LRESULT OnApplyFilter	(WPARAM wParam = 0, LPARAM lParam = 0);
	DECLARE_MESSAGE_MAP()

	//virtual void OnWindowClosing(BOOL IsChildWindow, BOOL* Cancel);
	virtual void OnPrivacyImpactedStateChange( BOOL bImpacted );
	virtual void OnSetSecureLockIcon(long SecureLockIcon);
	//virtual void OnFileDownload(BOOL* Cancel);
	virtual void OnWindowSetLeft(long Left);
	virtual void OnWindowSetTop(long Top);
	virtual void OnWindowSetWidth(long Width);
	virtual void OnWindowSetHeight(long Height);
	afx_msg void OnNewWindow3(LPDISPATCH FAR* ppDisp, BOOL FAR* Cancel, DWORD dwFlags, LPCTSTR bstrUrlContext, LPCTSTR bstrUrl);
	DECLARE_EVENTSINK_MAP()
};

#ifndef _DEBUG	// patriotView.cpp t@CfobO̎gp܂B
inline CPatriotDoc* CPatriotView::GetDocument()
   { return (CPatriotDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PATRIOTVIEW_H__2678F54E_D704_11D5_8799_E58356340A34__INCLUDED_)
